/**
 * @class vespa::config::content::AllClustersBucketSpaces
 * @ingroup config
 *
 * @brief This is an autogenerated class for handling VESPA config.
 *
 * This class is autogenerated by vespa from a config definition file.
 * To subscribe to config, you need to include the config/config.h header, 
 * and create a ConfigSubscriber in order to subscribe for config.
 *
 * Copyright Vespa.ai. Licensed under the terms of the Apache 2.0 license. See LICENSE in the project root.
 */
#ifndef CLOUD_CONFIG_VESPA_CONFIG_CONTENT_ALLCLUSTERSBUCKETSPACES_H
#define CLOUD_CONFIG_VESPA_CONFIG_CONTENT_ALLCLUSTERSBUCKETSPACES_H

#include <vespa/config/configgen/configinstance.h>
#include <vespa/config/common/types.h>

namespace config {
    class ConfigValue;
    class ConfigPayload;
}

namespace vespalib::slime {
    struct Inspector;
    struct Cursor;
}

namespace vespa::config::content {

namespace internal {

/**
 * This class contains the config. DO NOT USE THIS CLASS DIRECTLY. Use the typedeffed
 * versions after this class declaration.
 */
class InternalAllClustersBucketSpacesType : public ::config::ConfigInstance
{
public:
    typedef std::unique_ptr<const InternalAllClustersBucketSpacesType> UP;
    class Cluster {
    public:
        class DocumentType {
        public:
            DocumentType(const ::config::StringVector & __lines);
            DocumentType(const vespalib::slime::Inspector & __inspector);
            DocumentType(const ::config::ConfigPayload & __payload);
            DocumentType()  noexcept;
            DocumentType(const DocumentType & __rhs) noexcept;
            DocumentType & operator = (const DocumentType & __rhs) noexcept;
            DocumentType(DocumentType && __rhs) noexcept;
            DocumentType & operator = (DocumentType && __rhs) noexcept;
            ~DocumentType();

            bool operator==(const DocumentType& __rhs) const noexcept;
            bool operator!=(const DocumentType& __rhs) const noexcept;

            void serialize(vespalib::slime::Cursor & __cursor) const;

            // This config contains the document types handled by all content
            // clusters
            // and the bucket spaces they belong to.

            /**
             * The bucket space a document type in a particular cluster belongs
             * to.
             */
            vespalib::string bucketSpace;
        };
        typedef std::vector<DocumentType> DocumentTypeVector;

        typedef std::map<vespalib::string, DocumentType> DocumentTypeMap;

        Cluster(const ::config::StringVector & __lines);
        Cluster(const vespalib::slime::Inspector & __inspector);
        Cluster(const ::config::ConfigPayload & __payload);
        Cluster() ;
        Cluster(const Cluster & __rhs);
        Cluster & operator = (const Cluster & __rhs);
        Cluster(Cluster && __rhs) noexcept;
        Cluster & operator = (Cluster && __rhs) noexcept;
        ~Cluster();

        bool operator==(const Cluster& __rhs) const noexcept;
        bool operator!=(const Cluster& __rhs) const noexcept;

        void serialize(vespalib::slime::Cursor & __cursor) const;
        DocumentTypeMap documentType;
    };
    typedef std::vector<Cluster> ClusterVector;

    typedef std::map<vespalib::string, Cluster> ClusterMap;

    const vespalib::string & defName() const override { return CONFIG_DEF_NAME; }
    const vespalib::string & defMd5() const override { return CONFIG_DEF_MD5; }
    const vespalib::string & defNamespace() const override { return CONFIG_DEF_NAMESPACE; }
    void serialize(::config::ConfigDataBuffer & __buffer) const override;
    InternalAllClustersBucketSpacesType(const ::config::ConfigValue & __value);
    InternalAllClustersBucketSpacesType(const ::config::ConfigDataBuffer & __value);
    InternalAllClustersBucketSpacesType(const ::config::ConfigPayload & __payload);
    InternalAllClustersBucketSpacesType() ;
    InternalAllClustersBucketSpacesType(const InternalAllClustersBucketSpacesType & __rhs);
    InternalAllClustersBucketSpacesType & operator = (const InternalAllClustersBucketSpacesType & __rhs);
    InternalAllClustersBucketSpacesType(InternalAllClustersBucketSpacesType && __rhs) noexcept;
    InternalAllClustersBucketSpacesType & operator = (InternalAllClustersBucketSpacesType && __rhs) noexcept;
    ~InternalAllClustersBucketSpacesType();

    bool operator==(const InternalAllClustersBucketSpacesType& __rhs) const noexcept;
    bool operator!=(const InternalAllClustersBucketSpacesType& __rhs) const noexcept;

    static const vespalib::string CONFIG_DEF_MD5;
    static const vespalib::string CONFIG_DEF_NAME;
    static const vespalib::string CONFIG_DEF_NAMESPACE;
    static const ::config::StringVector CONFIG_DEF_SCHEMA;
    static const int64_t CONFIG_DEF_SERIALIZE_VERSION;

    ClusterMap cluster;
};

} // namespace internal

typedef internal::InternalAllClustersBucketSpacesType AllClustersBucketSpacesConfigBuilder;
typedef const internal::InternalAllClustersBucketSpacesType AllClustersBucketSpacesConfig;

} // namespace vespa::config::content
#endif // VESPA_config_VESPA_CONFIG_CONTENT_ALLCLUSTERSBUCKETSPACES_H
