/**
 * @class cloud::config::ApplicationId
 * @ingroup config
 *
 * @brief This is an autogenerated class for handling VESPA config.
 *
 * This class is autogenerated by vespa from a config definition file.
 * To subscribe to config, you need to include the config/config.h header, 
 * and create a ConfigSubscriber in order to subscribe for config.
 *
 * Copyright Vespa.ai. Licensed under the terms of the Apache 2.0 license. See LICENSE in the project root.
 * Application Id config (tenant, application, instance)
 */
#ifndef CLOUD_CONFIG_CLOUD_CONFIG_APPLICATIONID_H
#define CLOUD_CONFIG_CLOUD_CONFIG_APPLICATIONID_H

#include <vespa/config/configgen/configinstance.h>
#include <vespa/config/common/types.h>

namespace config {
    class ConfigValue;
    class ConfigPayload;
}

namespace vespalib::slime {
    struct Inspector;
    struct Cursor;
}

namespace cloud::config {

namespace internal {

/**
 * This class contains the config. DO NOT USE THIS CLASS DIRECTLY. Use the typedeffed
 * versions after this class declaration.
 */
class InternalApplicationIdType : public ::config::ConfigInstance
{
public:
    typedef std::unique_ptr<const InternalApplicationIdType> UP;
    const vespalib::string & defName() const override { return CONFIG_DEF_NAME; }
    const vespalib::string & defMd5() const override { return CONFIG_DEF_MD5; }
    const vespalib::string & defNamespace() const override { return CONFIG_DEF_NAMESPACE; }
    void serialize(::config::ConfigDataBuffer & __buffer) const override;
    InternalApplicationIdType(const ::config::ConfigValue & __value);
    InternalApplicationIdType(const ::config::ConfigDataBuffer & __value);
    InternalApplicationIdType(const ::config::ConfigPayload & __payload);
    InternalApplicationIdType()  noexcept;
    InternalApplicationIdType(const InternalApplicationIdType & __rhs) noexcept;
    InternalApplicationIdType & operator = (const InternalApplicationIdType & __rhs) noexcept;
    InternalApplicationIdType(InternalApplicationIdType && __rhs) noexcept;
    InternalApplicationIdType & operator = (InternalApplicationIdType && __rhs) noexcept;
    ~InternalApplicationIdType();

    bool operator==(const InternalApplicationIdType& __rhs) const noexcept;
    bool operator!=(const InternalApplicationIdType& __rhs) const noexcept;

    static const vespalib::string CONFIG_DEF_MD5;
    static const vespalib::string CONFIG_DEF_NAME;
    static const vespalib::string CONFIG_DEF_NAMESPACE;
    static const ::config::StringVector CONFIG_DEF_SCHEMA;
    static const int64_t CONFIG_DEF_SERIALIZE_VERSION;

    vespalib::string tenant; // Default: "(unknowntenant)"
    vespalib::string application; // Default: "(unknownapplication)"
    vespalib::string instance; // Default: "(unknowninstance)"
};

} // namespace internal

typedef internal::InternalApplicationIdType ApplicationIdConfigBuilder;
typedef const internal::InternalApplicationIdType ApplicationIdConfig;

} // namespace cloud::config
#endif // VESPA_config_CLOUD_CONFIG_APPLICATIONID_H
