/**
 * @class vespa::config::content::core::Bucketspaces
 * @ingroup config
 *
 * @brief This is an autogenerated class for handling VESPA config.
 *
 * This class is autogenerated by vespa from a config definition file.
 * To subscribe to config, you need to include the config/config.h header, 
 * and create a ConfigSubscriber in order to subscribe for config.
 *
 * Copyright Vespa.ai. Licensed under the terms of the Apache 2.0 license. See LICENSE in the project root.
 */
#ifndef CLOUD_CONFIG_VESPA_CONFIG_CONTENT_CORE_BUCKETSPACES_H
#define CLOUD_CONFIG_VESPA_CONFIG_CONTENT_CORE_BUCKETSPACES_H

#include <vespa/config/configgen/configinstance.h>
#include <vespa/config/common/types.h>

namespace config {
    class ConfigValue;
    class ConfigPayload;
}

namespace vespalib::slime {
    struct Inspector;
    struct Cursor;
}

namespace vespa::config::content::core {

namespace internal {

/**
 * This class contains the config. DO NOT USE THIS CLASS DIRECTLY. Use the typedeffed
 * versions after this class declaration.
 */
class InternalBucketspacesType : public ::config::ConfigInstance
{
public:
    typedef std::unique_ptr<const InternalBucketspacesType> UP;
    class Documenttype {
    public:
        Documenttype(const ::config::StringVector & __lines);
        Documenttype(const vespalib::slime::Inspector & __inspector);
        Documenttype(const ::config::ConfigPayload & __payload);
        Documenttype()  noexcept;
        Documenttype(const Documenttype & __rhs) noexcept;
        Documenttype & operator = (const Documenttype & __rhs) noexcept;
        Documenttype(Documenttype && __rhs) noexcept;
        Documenttype & operator = (Documenttype && __rhs) noexcept;
        ~Documenttype();

        bool operator==(const Documenttype& __rhs) const noexcept;
        bool operator!=(const Documenttype& __rhs) const noexcept;

        void serialize(vespalib::slime::Cursor & __cursor) const;

        // This config contains the document types handled by a given content
        // cluster
        // and the bucket space they belong to.

        /** The name of a document type. */
        vespalib::string name;

        /** The bucket space this document type belongs to. */
        vespalib::string bucketspace;
    };
    typedef std::vector<Documenttype> DocumenttypeVector;

    typedef std::map<vespalib::string, Documenttype> DocumenttypeMap;

    const vespalib::string & defName() const override { return CONFIG_DEF_NAME; }
    const vespalib::string & defMd5() const override { return CONFIG_DEF_MD5; }
    const vespalib::string & defNamespace() const override { return CONFIG_DEF_NAMESPACE; }
    void serialize(::config::ConfigDataBuffer & __buffer) const override;
    InternalBucketspacesType(const ::config::ConfigValue & __value);
    InternalBucketspacesType(const ::config::ConfigDataBuffer & __value);
    InternalBucketspacesType(const ::config::ConfigPayload & __payload);
    InternalBucketspacesType() ;
    InternalBucketspacesType(const InternalBucketspacesType & __rhs);
    InternalBucketspacesType & operator = (const InternalBucketspacesType & __rhs);
    InternalBucketspacesType(InternalBucketspacesType && __rhs) noexcept;
    InternalBucketspacesType & operator = (InternalBucketspacesType && __rhs) noexcept;
    ~InternalBucketspacesType();

    bool operator==(const InternalBucketspacesType& __rhs) const noexcept;
    bool operator!=(const InternalBucketspacesType& __rhs) const noexcept;

    static const vespalib::string CONFIG_DEF_MD5;
    static const vespalib::string CONFIG_DEF_NAME;
    static const vespalib::string CONFIG_DEF_NAMESPACE;
    static const ::config::StringVector CONFIG_DEF_SCHEMA;
    static const int64_t CONFIG_DEF_SERIALIZE_VERSION;

    DocumenttypeVector documenttype;
};

} // namespace internal

typedef internal::InternalBucketspacesType BucketspacesConfigBuilder;
typedef const internal::InternalBucketspacesType BucketspacesConfig;

} // namespace vespa::config::content::core
#endif // VESPA_config_VESPA_CONFIG_CONTENT_CORE_BUCKETSPACES_H
