/**
 * @class cloud::config::ClusterList
 * @ingroup config
 *
 * @brief This is an autogenerated class for handling VESPA config.
 *
 * This class is autogenerated by vespa from a config definition file.
 * To subscribe to config, you need to include the config/config.h header, 
 * and create a ConfigSubscriber in order to subscribe for config.
 *
 * Copyright Vespa.ai. Licensed under the terms of the Apache 2.0 license. See LICENSE in the project root.
 */
#ifndef CLOUD_CONFIG_CLOUD_CONFIG_CLUSTERLIST_H
#define CLOUD_CONFIG_CLOUD_CONFIG_CLUSTERLIST_H

#include <vespa/config/configgen/configinstance.h>
#include <vespa/config/common/types.h>

namespace config {
    class ConfigValue;
    class ConfigPayload;
}

namespace vespalib::slime {
    struct Inspector;
    struct Cursor;
}

namespace cloud::config {

namespace internal {

/**
 * This class contains the config. DO NOT USE THIS CLASS DIRECTLY. Use the typedeffed
 * versions after this class declaration.
 */
class InternalClusterListType : public ::config::ConfigInstance
{
public:
    typedef std::unique_ptr<const InternalClusterListType> UP;
    class Storage {
    public:
        Storage(const ::config::StringVector & __lines);
        Storage(const vespalib::slime::Inspector & __inspector);
        Storage(const ::config::ConfigPayload & __payload);
        Storage()  noexcept;
        Storage(const Storage & __rhs) noexcept;
        Storage & operator = (const Storage & __rhs) noexcept;
        Storage(Storage && __rhs) noexcept;
        Storage & operator = (Storage && __rhs) noexcept;
        ~Storage();

        bool operator==(const Storage& __rhs) const noexcept;
        bool operator!=(const Storage& __rhs) const noexcept;

        void serialize(vespalib::slime::Cursor & __cursor) const;
        vespalib::string name;
        vespalib::string configid; // Default: ""
    };
    typedef std::vector<Storage> StorageVector;

    typedef std::map<vespalib::string, Storage> StorageMap;

    const vespalib::string & defName() const override { return CONFIG_DEF_NAME; }
    const vespalib::string & defMd5() const override { return CONFIG_DEF_MD5; }
    const vespalib::string & defNamespace() const override { return CONFIG_DEF_NAMESPACE; }
    void serialize(::config::ConfigDataBuffer & __buffer) const override;
    InternalClusterListType(const ::config::ConfigValue & __value);
    InternalClusterListType(const ::config::ConfigDataBuffer & __value);
    InternalClusterListType(const ::config::ConfigPayload & __payload);
    InternalClusterListType() ;
    InternalClusterListType(const InternalClusterListType & __rhs);
    InternalClusterListType & operator = (const InternalClusterListType & __rhs);
    InternalClusterListType(InternalClusterListType && __rhs) noexcept;
    InternalClusterListType & operator = (InternalClusterListType && __rhs) noexcept;
    ~InternalClusterListType();

    bool operator==(const InternalClusterListType& __rhs) const noexcept;
    bool operator!=(const InternalClusterListType& __rhs) const noexcept;

    static const vespalib::string CONFIG_DEF_MD5;
    static const vespalib::string CONFIG_DEF_NAME;
    static const vespalib::string CONFIG_DEF_NAMESPACE;
    static const ::config::StringVector CONFIG_DEF_SCHEMA;
    static const int64_t CONFIG_DEF_SERIALIZE_VERSION;

    StorageVector storage;
};

} // namespace internal

typedef internal::InternalClusterListType ClusterListConfigBuilder;
typedef const internal::InternalClusterListType ClusterListConfig;

} // namespace cloud::config
#endif // VESPA_config_CLOUD_CONFIG_CLUSTERLIST_H
