/**
 * @class cloud::config::DataplaneProxy
 * @ingroup config
 *
 * @brief This is an autogenerated class for handling VESPA config.
 *
 * This class is autogenerated by vespa from a config definition file.
 * To subscribe to config, you need to include the config/config.h header, 
 * and create a ConfigSubscriber in order to subscribe for config.
 *
 * Copyright Vespa.ai. Licensed under the terms of the Apache 2.0 license. See LICENSE in the project root.
 */
#ifndef CLOUD_CONFIG_CLOUD_CONFIG_DATAPLANEPROXY_H
#define CLOUD_CONFIG_CLOUD_CONFIG_DATAPLANEPROXY_H

#include <vespa/config/configgen/configinstance.h>
#include <vespa/config/common/types.h>

namespace config {
    class ConfigValue;
    class ConfigPayload;
}

namespace vespalib::slime {
    struct Inspector;
    struct Cursor;
}

namespace cloud::config {

namespace internal {

/**
 * This class contains the config. DO NOT USE THIS CLASS DIRECTLY. Use the typedeffed
 * versions after this class declaration.
 */
class InternalDataplaneProxyType : public ::config::ConfigInstance
{
public:
    typedef std::unique_ptr<const InternalDataplaneProxyType> UP;
    const vespalib::string & defName() const override { return CONFIG_DEF_NAME; }
    const vespalib::string & defMd5() const override { return CONFIG_DEF_MD5; }
    const vespalib::string & defNamespace() const override { return CONFIG_DEF_NAMESPACE; }
    void serialize(::config::ConfigDataBuffer & __buffer) const override;
    InternalDataplaneProxyType(const ::config::ConfigValue & __value);
    InternalDataplaneProxyType(const ::config::ConfigDataBuffer & __value);
    InternalDataplaneProxyType(const ::config::ConfigPayload & __payload);
    InternalDataplaneProxyType() ;
    InternalDataplaneProxyType(const InternalDataplaneProxyType & __rhs);
    InternalDataplaneProxyType & operator = (const InternalDataplaneProxyType & __rhs);
    InternalDataplaneProxyType(InternalDataplaneProxyType && __rhs) noexcept;
    InternalDataplaneProxyType & operator = (InternalDataplaneProxyType && __rhs) noexcept;
    ~InternalDataplaneProxyType();

    bool operator==(const InternalDataplaneProxyType& __rhs) const noexcept;
    bool operator!=(const InternalDataplaneProxyType& __rhs) const noexcept;

    static const vespalib::string CONFIG_DEF_MD5;
    static const vespalib::string CONFIG_DEF_NAME;
    static const vespalib::string CONFIG_DEF_NAMESPACE;
    static const ::config::StringVector CONFIG_DEF_SCHEMA;
    static const int64_t CONFIG_DEF_SERIALIZE_VERSION;


    /** The port Jdisc will be listening on */
    int32_t tokenPort;
    int32_t mtlsPort;

    /** Server certificate and key to be used when creating server socket */
    vespalib::string serverCertificate;
    vespalib::string serverKey;

    /** Host names that should be considered token endpoints */
    ::config::StringVector tokenEndpoints;
};

} // namespace internal

typedef internal::InternalDataplaneProxyType DataplaneProxyConfigBuilder;
typedef const internal::InternalDataplaneProxyType DataplaneProxyConfig;

} // namespace cloud::config
#endif // VESPA_config_CLOUD_CONFIG_DATAPLANEPROXY_H
