/**
 * @class vespa::config::search::core::Hwinfo
 * @ingroup config
 *
 * @brief This is an autogenerated class for handling VESPA config.
 *
 * This class is autogenerated by vespa from a config definition file.
 * To subscribe to config, you need to include the config/config.h header, 
 * and create a ConfigSubscriber in order to subscribe for config.
 *
 * Copyright Vespa.ai. Licensed under the terms of the Apache 2.0 license. See LICENSE in the project root.
 */
#ifndef CLOUD_CONFIG_VESPA_CONFIG_SEARCH_CORE_HWINFO_H
#define CLOUD_CONFIG_VESPA_CONFIG_SEARCH_CORE_HWINFO_H

#include <vespa/config/configgen/configinstance.h>
#include <vespa/config/common/types.h>

namespace config {
    class ConfigValue;
    class ConfigPayload;
}

namespace vespalib::slime {
    struct Inspector;
    struct Cursor;
}

namespace vespa::config::search::core {

namespace internal {

/**
 * This class contains the config. DO NOT USE THIS CLASS DIRECTLY. Use the typedeffed
 * versions after this class declaration.
 */
class InternalHwinfoType : public ::config::ConfigInstance
{
public:
    typedef std::unique_ptr<const InternalHwinfoType> UP;
    class Disk {
    public:
        Disk(const ::config::StringVector & __lines);
        Disk(const vespalib::slime::Inspector & __inspector);
        Disk(const ::config::ConfigPayload & __payload);
        Disk()  noexcept;
        Disk(const Disk & __rhs) noexcept;
        Disk & operator = (const Disk & __rhs) noexcept;
        Disk(Disk && __rhs) noexcept;
        Disk & operator = (Disk && __rhs) noexcept;
        ~Disk();

        bool operator==(const Disk& __rhs) const noexcept;
        bool operator!=(const Disk& __rhs) const noexcept;

        void serialize(vespalib::slime::Cursor & __cursor) const;

        /**
         * Write speed, MiB/s, typically measured by writing 1 GiB data to disk.
         */
        double writespeed; // Default: 0.0

        /** Sample time, in seconds since epoch */
        int64_t sampletime; // Default: 0
    };
    typedef std::vector<Disk> DiskVector;

    typedef std::map<vespalib::string, Disk> DiskMap;

    const vespalib::string & defName() const override { return CONFIG_DEF_NAME; }
    const vespalib::string & defMd5() const override { return CONFIG_DEF_MD5; }
    const vespalib::string & defNamespace() const override { return CONFIG_DEF_NAMESPACE; }
    void serialize(::config::ConfigDataBuffer & __buffer) const override;
    InternalHwinfoType(const ::config::ConfigValue & __value);
    InternalHwinfoType(const ::config::ConfigDataBuffer & __value);
    InternalHwinfoType(const ::config::ConfigPayload & __payload);
    InternalHwinfoType()  noexcept;
    InternalHwinfoType(const InternalHwinfoType & __rhs) noexcept;
    InternalHwinfoType & operator = (const InternalHwinfoType & __rhs) noexcept;
    InternalHwinfoType(InternalHwinfoType && __rhs) noexcept;
    InternalHwinfoType & operator = (InternalHwinfoType && __rhs) noexcept;
    ~InternalHwinfoType();

    bool operator==(const InternalHwinfoType& __rhs) const noexcept;
    bool operator!=(const InternalHwinfoType& __rhs) const noexcept;

    static const vespalib::string CONFIG_DEF_MD5;
    static const vespalib::string CONFIG_DEF_NAME;
    static const vespalib::string CONFIG_DEF_NAMESPACE;
    static const ::config::StringVector CONFIG_DEF_SCHEMA;
    static const int64_t CONFIG_DEF_SERIALIZE_VERSION;

    Disk disk;
};

} // namespace internal

typedef internal::InternalHwinfoType HwinfoConfigBuilder;
typedef const internal::InternalHwinfoType HwinfoConfig;

} // namespace vespa::config::search::core
#endif // VESPA_config_VESPA_CONFIG_SEARCH_CORE_HWINFO_H
