/**
 * @class vespa::configdefinition::Ilscripts
 * @ingroup config
 *
 * @brief This is an autogenerated class for handling VESPA config.
 *
 * This class is autogenerated by vespa from a config definition file.
 * To subscribe to config, you need to include the config/config.h header, 
 * and create a ConfigSubscriber in order to subscribe for config.
 *
 * Copyright Vespa.ai. Licensed under the terms of the Apache 2.0 license. See LICENSE in the project root.
 */
#ifndef CLOUD_CONFIG_VESPA_CONFIGDEFINITION_ILSCRIPTS_H
#define CLOUD_CONFIG_VESPA_CONFIGDEFINITION_ILSCRIPTS_H

#include <vespa/config/configgen/configinstance.h>
#include <vespa/config/common/types.h>

namespace config {
    class ConfigValue;
    class ConfigPayload;
}

namespace vespalib::slime {
    struct Inspector;
    struct Cursor;
}

namespace vespa::configdefinition {

namespace internal {

/**
 * This class contains the config. DO NOT USE THIS CLASS DIRECTLY. Use the typedeffed
 * versions after this class declaration.
 */
class InternalIlscriptsType : public ::config::ConfigInstance
{
public:
    typedef std::unique_ptr<const InternalIlscriptsType> UP;
    class Ilscript {
    public:
        Ilscript(const ::config::StringVector & __lines);
        Ilscript(const vespalib::slime::Inspector & __inspector);
        Ilscript(const ::config::ConfigPayload & __payload);
        Ilscript() ;
        Ilscript(const Ilscript & __rhs);
        Ilscript & operator = (const Ilscript & __rhs);
        Ilscript(Ilscript && __rhs) noexcept;
        Ilscript & operator = (Ilscript && __rhs) noexcept;
        ~Ilscript();

        bool operator==(const Ilscript& __rhs) const noexcept;
        bool operator!=(const Ilscript& __rhs) const noexcept;

        void serialize(vespalib::slime::Cursor & __cursor) const;
        vespalib::string doctype;
        ::config::StringVector docfield;
        ::config::StringVector content;
    };
    typedef std::vector<Ilscript> IlscriptVector;

    typedef std::map<vespalib::string, Ilscript> IlscriptMap;

    const vespalib::string & defName() const override { return CONFIG_DEF_NAME; }
    const vespalib::string & defMd5() const override { return CONFIG_DEF_MD5; }
    const vespalib::string & defNamespace() const override { return CONFIG_DEF_NAMESPACE; }
    void serialize(::config::ConfigDataBuffer & __buffer) const override;
    InternalIlscriptsType(const ::config::ConfigValue & __value);
    InternalIlscriptsType(const ::config::ConfigDataBuffer & __value);
    InternalIlscriptsType(const ::config::ConfigPayload & __payload);
    InternalIlscriptsType() ;
    InternalIlscriptsType(const InternalIlscriptsType & __rhs);
    InternalIlscriptsType & operator = (const InternalIlscriptsType & __rhs);
    InternalIlscriptsType(InternalIlscriptsType && __rhs) noexcept;
    InternalIlscriptsType & operator = (InternalIlscriptsType && __rhs) noexcept;
    ~InternalIlscriptsType();

    bool operator==(const InternalIlscriptsType& __rhs) const noexcept;
    bool operator!=(const InternalIlscriptsType& __rhs) const noexcept;

    static const vespalib::string CONFIG_DEF_MD5;
    static const vespalib::string CONFIG_DEF_NAME;
    static const vespalib::string CONFIG_DEF_NAMESPACE;
    static const ::config::StringVector CONFIG_DEF_SCHEMA;
    static const int64_t CONFIG_DEF_SERIALIZE_VERSION;


    /** The maximum number of occurrences of a given term to index per field */
    int32_t maxtermoccurrences; // Default: 10000

    /** The maximum number of characters for a token */
    int32_t maxtokenlength; // Default: 1000
    int32_t fieldmatchmaxlength; // Default: 1000000
    IlscriptVector ilscript;
};

} // namespace internal

typedef internal::InternalIlscriptsType IlscriptsConfigBuilder;
typedef const internal::InternalIlscriptsType IlscriptsConfig;

} // namespace vespa::configdefinition
#endif // VESPA_config_VESPA_CONFIGDEFINITION_ILSCRIPTS_H
