/**
 * @class cloud::config::Logforwarder
 * @ingroup config
 *
 * @brief This is an autogenerated class for handling VESPA config.
 *
 * This class is autogenerated by vespa from a config definition file.
 * To subscribe to config, you need to include the config/config.h header, 
 * and create a ConfigSubscriber in order to subscribe for config.
 *
 * Copyright Vespa.ai. Licensed under the terms of the Apache 2.0 license. See LICENSE in the project root.
 */
#ifndef CLOUD_CONFIG_CLOUD_CONFIG_LOGFORWARDER_H
#define CLOUD_CONFIG_CLOUD_CONFIG_LOGFORWARDER_H

#include <vespa/config/configgen/configinstance.h>
#include <vespa/config/common/types.h>

namespace config {
    class ConfigValue;
    class ConfigPayload;
}

namespace vespalib::slime {
    struct Inspector;
    struct Cursor;
}

namespace cloud::config {

namespace internal {

/**
 * This class contains the config. DO NOT USE THIS CLASS DIRECTLY. Use the typedeffed
 * versions after this class declaration.
 */
class InternalLogforwarderType : public ::config::ConfigInstance
{
public:
    typedef std::unique_ptr<const InternalLogforwarderType> UP;
    const vespalib::string & defName() const override { return CONFIG_DEF_NAME; }
    const vespalib::string & defMd5() const override { return CONFIG_DEF_MD5; }
    const vespalib::string & defNamespace() const override { return CONFIG_DEF_NAMESPACE; }
    void serialize(::config::ConfigDataBuffer & __buffer) const override;
    InternalLogforwarderType(const ::config::ConfigValue & __value);
    InternalLogforwarderType(const ::config::ConfigDataBuffer & __value);
    InternalLogforwarderType(const ::config::ConfigPayload & __payload);
    InternalLogforwarderType()  noexcept;
    InternalLogforwarderType(const InternalLogforwarderType & __rhs) noexcept;
    InternalLogforwarderType & operator = (const InternalLogforwarderType & __rhs) noexcept;
    InternalLogforwarderType(InternalLogforwarderType && __rhs) noexcept;
    InternalLogforwarderType & operator = (InternalLogforwarderType && __rhs) noexcept;
    ~InternalLogforwarderType();

    bool operator==(const InternalLogforwarderType& __rhs) const noexcept;
    bool operator!=(const InternalLogforwarderType& __rhs) const noexcept;

    static const vespalib::string CONFIG_DEF_MD5;
    static const vespalib::string CONFIG_DEF_NAME;
    static const vespalib::string CONFIG_DEF_NAMESPACE;
    static const ::config::StringVector CONFIG_DEF_SCHEMA;
    static const int64_t CONFIG_DEF_SERIALIZE_VERSION;


    /**
     * only splunk type config for now
     */
    vespalib::string deploymentServer; // Default: ""
    vespalib::string clientName; // Default: ""
    vespalib::string splunkHome; // Default: "/opt/splunkforwarder"
    int32_t phoneHomeInterval; // Default: 60
    vespalib::string role; // Default: ""
};

} // namespace internal

typedef internal::InternalLogforwarderType LogforwarderConfigBuilder;
typedef const internal::InternalLogforwarderType LogforwarderConfig;

} // namespace cloud::config
#endif // VESPA_config_CLOUD_CONFIG_LOGFORWARDER_H
