#include "config-messagetyperouteselectorpolicy.h"
#include <vespa/config/common/configvalue.h>
#include <vespa/config/common/exceptions.h>
#include <vespa/config/configgen/configpayload.h>
#include <vespa/config/print/configdatabuffer.h>
#include <vespa/config/common/configparser.h>
#include <vespa/vespalib/data/slime/convenience.h>
#include <vespa/vespalib/data/slime/slime.h>
#include <vespa/vespalib/stllike/asciistream.h>
#include <vespa/config/configgen/vector_inserter.hpp>
#include <vespa/config/configgen/map_inserter.hpp>

namespace vespa::config::content {

namespace internal {

using ::config::ConfigParser;
using ::config::InvalidConfigException;
using ::config::ConfigInstance;
using ::config::ConfigValue;
using namespace vespalib::slime::convenience;

const vespalib::string InternalMessagetyperouteselectorpolicyType::CONFIG_DEF_MD5("3f950702e25c5b896922f81091100a3a");
const vespalib::string InternalMessagetyperouteselectorpolicyType::CONFIG_DEF_NAME("messagetyperouteselectorpolicy");
const vespalib::string InternalMessagetyperouteselectorpolicyType::CONFIG_DEF_NAMESPACE("vespa.config.content");
const int64_t InternalMessagetyperouteselectorpolicyType::CONFIG_DEF_SERIALIZE_VERSION(1);
const static vespalib::string __internalDefSchema[] = {
"namespace=vespa.config.content",
"defaultroute string",
"route[].name string",
"route[].messagetype int",
};
const ::config::StringVector InternalMessagetyperouteselectorpolicyType::CONFIG_DEF_SCHEMA(__internalDefSchema,
    __internalDefSchema + (sizeof(__internalDefSchema) / 
                           sizeof(__internalDefSchema[0])));

InternalMessagetyperouteselectorpolicyType::Route::Route() noexcept
    : name(),
      messagetype(0)
{
}

InternalMessagetyperouteselectorpolicyType::Route::Route(const Route & __rhs) noexcept = default;
InternalMessagetyperouteselectorpolicyType::Route & InternalMessagetyperouteselectorpolicyType::Route::operator = (const Route & __rhs) noexcept = default;
InternalMessagetyperouteselectorpolicyType::Route::Route(Route && __rhs) noexcept = default;
InternalMessagetyperouteselectorpolicyType::Route & InternalMessagetyperouteselectorpolicyType::Route::operator = (Route && __rhs) noexcept = default;
InternalMessagetyperouteselectorpolicyType::Route::~Route() = default; 
InternalMessagetyperouteselectorpolicyType::Route::Route(const ::config::StringVector & __lines)
{
    std::set<vespalib::string> __remainingValuesToParse = ConfigParser::getUniqueNonWhiteSpaceLines(__lines);
    name = ConfigParser::parse<vespalib::string>("name", __lines);
    ConfigParser::stripLinesForKey("name", __remainingValuesToParse);
    messagetype = ConfigParser::parse<int32_t>("messagetype", __lines);
    ConfigParser::stripLinesForKey("messagetype", __remainingValuesToParse);
}

bool
InternalMessagetyperouteselectorpolicyType::Route::
operator==(const Route& __rhs) const noexcept
{
    return (name == __rhs.name &&
            messagetype == __rhs.messagetype);
}

bool
InternalMessagetyperouteselectorpolicyType::Route::
operator!=(const Route& __rhs) const noexcept
{
    return !(operator==(__rhs));
}

void
InternalMessagetyperouteselectorpolicyType::Route::serialize(vespalib::slime::Cursor & __cursor) const
{
    {
        vespalib::slime::Cursor & __c = __cursor.setObject("name");
        __c.setString("type", "string");
        __c.setString("value", vespalib::Memory(name));
    }
    {
        vespalib::slime::Cursor & __c = __cursor.setObject("messagetype");
        __c.setString("type", "int");
        __c.setLong("value", messagetype);
    }
}

InternalMessagetyperouteselectorpolicyType::Route::Route(const vespalib::slime::Inspector & __inspector)
{
    name = __inspector["name"]["value"].asString().make_string();
    messagetype = __inspector["messagetype"]["value"].asLong();
}

InternalMessagetyperouteselectorpolicyType::Route::Route(const ::config::ConfigPayload & __payload)
{
    const vespalib::slime::Inspector & __inspector(__payload.get());
    name = ::config::internal::ValueConverter<vespalib::string>()("name", __inspector["name"]);
    messagetype = ::config::internal::ValueConverter<int32_t>()("messagetype", __inspector["messagetype"]);
}

InternalMessagetyperouteselectorpolicyType::InternalMessagetyperouteselectorpolicyType()
    : defaultroute(),
      route()
{
}

InternalMessagetyperouteselectorpolicyType::InternalMessagetyperouteselectorpolicyType(const InternalMessagetyperouteselectorpolicyType & __rhs) = default;
InternalMessagetyperouteselectorpolicyType & InternalMessagetyperouteselectorpolicyType::operator =(const InternalMessagetyperouteselectorpolicyType & __rhs) = default;
InternalMessagetyperouteselectorpolicyType::InternalMessagetyperouteselectorpolicyType(InternalMessagetyperouteselectorpolicyType && __rhs) noexcept = default;
InternalMessagetyperouteselectorpolicyType & InternalMessagetyperouteselectorpolicyType::operator =(InternalMessagetyperouteselectorpolicyType && __rhs) noexcept = default;
InternalMessagetyperouteselectorpolicyType::~InternalMessagetyperouteselectorpolicyType() = default; 
InternalMessagetyperouteselectorpolicyType::InternalMessagetyperouteselectorpolicyType(const ConfigValue & __value)
{
    try {
        const ::config::StringVector & __lines(__value.getLines());
        std::set<vespalib::string> __remainingValuesToParse = ConfigParser::getUniqueNonWhiteSpaceLines(__lines);
        defaultroute = ConfigParser::parse<vespalib::string>("defaultroute", __lines);
        ConfigParser::stripLinesForKey("defaultroute", __remainingValuesToParse);
        route = ConfigParser::parseArray<RouteVector>("route", __lines);
        ConfigParser::stripLinesForKey("route", __remainingValuesToParse);
    } catch (InvalidConfigException & __ice) {
        throw InvalidConfigException("Error parsing config '" + CONFIG_DEF_NAME + "' in namespace '" + CONFIG_DEF_NAMESPACE + "': " + __ice.getMessage());
    }
}

bool
InternalMessagetyperouteselectorpolicyType::
operator==(const InternalMessagetyperouteselectorpolicyType& __rhs) const noexcept
{
    return (defaultroute == __rhs.defaultroute &&
            route == __rhs.route);
}

bool
InternalMessagetyperouteselectorpolicyType::
operator!=(const InternalMessagetyperouteselectorpolicyType& __rhs) const noexcept
{
    return !(operator==(__rhs));
}

void
InternalMessagetyperouteselectorpolicyType::serialize(::config::ConfigDataBuffer & __buffer) const
{
    vespalib::Slime & __slime(__buffer.slimeObject());
    vespalib::slime::Cursor & __croot = __slime.setObject();
    __croot.setDouble("version", CONFIG_DEF_SERIALIZE_VERSION);
    vespalib::slime::Cursor & __key = __croot.setObject("configKey");
    __key.setString("defName", vespalib::Memory(CONFIG_DEF_NAME));
    __key.setString("defNamespace", vespalib::Memory(CONFIG_DEF_NAMESPACE));
    __key.setString("defMd5", vespalib::Memory(CONFIG_DEF_MD5));
    vespalib::slime::Cursor & __keySchema =__key.setArray("defSchema");
    for (size_t i = 0; i < CONFIG_DEF_SCHEMA.size(); i++) {
        __keySchema.addString(vespalib::Memory(CONFIG_DEF_SCHEMA[i]));
    }
    vespalib::slime::Cursor & __cursor = __croot.setObject("configPayload");
    {
        vespalib::slime::Cursor & __c = __cursor.setObject("defaultroute");
        __c.setString("type", "string");
        __c.setString("value", vespalib::Memory(defaultroute));
    }
    {
        vespalib::slime::Cursor & __c = __cursor.setObject("route");
        __c.setString("type", "array");
        vespalib::slime::Cursor & __c2 = __c.setArray("value");
        for (const auto & child : route) {
            vespalib::slime::Cursor & __c3 = __c2.addObject();
            __c3.setString("type", "struct");
            Cursor & __c4 = __c3.setObject("value");
            child.serialize(__c4);
        }
    }
}

InternalMessagetyperouteselectorpolicyType::InternalMessagetyperouteselectorpolicyType(const ::config::ConfigDataBuffer & __buffer)
{
    const vespalib::Slime & __slime(__buffer.slimeObject());
    vespalib::slime::Inspector & __croot = __slime.get();
    vespalib::slime::Inspector & __inspector = __croot["configPayload"];
    defaultroute = __inspector["defaultroute"]["value"].asString().make_string();
    for (size_t __i = 0; __i < __inspector["route"]["value"].children(); __i++) {
        route.push_back(Route(__inspector["route"]["value"][__i]["value"]));
    }
}

InternalMessagetyperouteselectorpolicyType::InternalMessagetyperouteselectorpolicyType(const ::config::ConfigPayload & __payload)
{
    const vespalib::slime::Inspector & __inspector(__payload.get());
    defaultroute = ::config::internal::ValueConverter<vespalib::string>()("defaultroute", __inspector["defaultroute"]);
    ::config::internal::VectorInserter<RouteVector> __routeInserter(route);
    __inspector["route"].traverse(__routeInserter);
}

} // namespace internal

} // namespace vespa::config::content
