/**
 * @class vespa::config::content::Messagetyperouteselectorpolicy
 * @ingroup config
 *
 * @brief This is an autogenerated class for handling VESPA config.
 *
 * This class is autogenerated by vespa from a config definition file.
 * To subscribe to config, you need to include the config/config.h header, 
 * and create a ConfigSubscriber in order to subscribe for config.
 *
 * Copyright Vespa.ai. Licensed under the terms of the Apache 2.0 license. See LICENSE in the project root.
 */
#ifndef CLOUD_CONFIG_VESPA_CONFIG_CONTENT_MESSAGETYPEROUTESELECTORPOLICY_H
#define CLOUD_CONFIG_VESPA_CONFIG_CONTENT_MESSAGETYPEROUTESELECTORPOLICY_H

#include <vespa/config/configgen/configinstance.h>
#include <vespa/config/common/types.h>

namespace config {
    class ConfigValue;
    class ConfigPayload;
}

namespace vespalib::slime {
    struct Inspector;
    struct Cursor;
}

namespace vespa::config::content {

namespace internal {

/**
 * This class contains the config. DO NOT USE THIS CLASS DIRECTLY. Use the typedeffed
 * versions after this class declaration.
 */
class InternalMessagetyperouteselectorpolicyType : public ::config::ConfigInstance
{
public:
    typedef std::unique_ptr<const InternalMessagetyperouteselectorpolicyType> UP;
    class Route {
    public:
        Route(const ::config::StringVector & __lines);
        Route(const vespalib::slime::Inspector & __inspector);
        Route(const ::config::ConfigPayload & __payload);
        Route()  noexcept;
        Route(const Route & __rhs) noexcept;
        Route & operator = (const Route & __rhs) noexcept;
        Route(Route && __rhs) noexcept;
        Route & operator = (Route && __rhs) noexcept;
        ~Route();

        bool operator==(const Route& __rhs) const noexcept;
        bool operator!=(const Route& __rhs) const noexcept;

        void serialize(vespalib::slime::Cursor & __cursor) const;

        /** The name of the route. */
        vespalib::string name;

        /** The document protocol messagetype triggering this route. */
        int32_t messagetype;
    };
    typedef std::vector<Route> RouteVector;

    typedef std::map<vespalib::string, Route> RouteMap;

    const vespalib::string & defName() const override { return CONFIG_DEF_NAME; }
    const vespalib::string & defMd5() const override { return CONFIG_DEF_MD5; }
    const vespalib::string & defNamespace() const override { return CONFIG_DEF_NAMESPACE; }
    void serialize(::config::ConfigDataBuffer & __buffer) const override;
    InternalMessagetyperouteselectorpolicyType(const ::config::ConfigValue & __value);
    InternalMessagetyperouteselectorpolicyType(const ::config::ConfigDataBuffer & __value);
    InternalMessagetyperouteselectorpolicyType(const ::config::ConfigPayload & __payload);
    InternalMessagetyperouteselectorpolicyType() ;
    InternalMessagetyperouteselectorpolicyType(const InternalMessagetyperouteselectorpolicyType & __rhs);
    InternalMessagetyperouteselectorpolicyType & operator = (const InternalMessagetyperouteselectorpolicyType & __rhs);
    InternalMessagetyperouteselectorpolicyType(InternalMessagetyperouteselectorpolicyType && __rhs) noexcept;
    InternalMessagetyperouteselectorpolicyType & operator = (InternalMessagetyperouteselectorpolicyType && __rhs) noexcept;
    ~InternalMessagetyperouteselectorpolicyType();

    bool operator==(const InternalMessagetyperouteselectorpolicyType& __rhs) const noexcept;
    bool operator!=(const InternalMessagetyperouteselectorpolicyType& __rhs) const noexcept;

    static const vespalib::string CONFIG_DEF_MD5;
    static const vespalib::string CONFIG_DEF_NAME;
    static const vespalib::string CONFIG_DEF_NAMESPACE;
    static const ::config::StringVector CONFIG_DEF_SCHEMA;
    static const int64_t CONFIG_DEF_SERIALIZE_VERSION;


    /** Default route if no override is set for a type. */
    vespalib::string defaultroute;
    RouteVector route;
};

} // namespace internal

typedef internal::InternalMessagetyperouteselectorpolicyType MessagetyperouteselectorpolicyConfigBuilder;
typedef const internal::InternalMessagetyperouteselectorpolicyType MessagetyperouteselectorpolicyConfig;

} // namespace vespa::config::content
#endif // VESPA_config_VESPA_CONFIG_CONTENT_MESSAGETYPEROUTESELECTORPOLICY_H
