/**
 * @class vespa::config::search::core::RankingConstants
 * @ingroup config
 *
 * @brief This is an autogenerated class for handling VESPA config.
 *
 * This class is autogenerated by vespa from a config definition file.
 * To subscribe to config, you need to include the config/config.h header, 
 * and create a ConfigSubscriber in order to subscribe for config.
 *
 * Copyright Vespa.ai. Licensed under the terms of the Apache 2.0 license. See LICENSE in the project root.
 */
#ifndef CLOUD_CONFIG_VESPA_CONFIG_SEARCH_CORE_RANKINGCONSTANTS_H
#define CLOUD_CONFIG_VESPA_CONFIG_SEARCH_CORE_RANKINGCONSTANTS_H

#include <vespa/config/configgen/configinstance.h>
#include <vespa/config/common/types.h>

namespace config {
    class ConfigValue;
    class ConfigPayload;
}

namespace vespalib::slime {
    struct Inspector;
    struct Cursor;
}

namespace vespa::config::search::core {

namespace internal {

/**
 * This class contains the config. DO NOT USE THIS CLASS DIRECTLY. Use the typedeffed
 * versions after this class declaration.
 */
class InternalRankingConstantsType : public ::config::ConfigInstance
{
public:
    typedef std::unique_ptr<const InternalRankingConstantsType> UP;
    class Constant {
    public:
        Constant(const ::config::StringVector & __lines);
        Constant(const vespalib::slime::Inspector & __inspector);
        Constant(const ::config::ConfigPayload & __payload);
        Constant()  noexcept;
        Constant(const Constant & __rhs) noexcept;
        Constant & operator = (const Constant & __rhs) noexcept;
        Constant(Constant && __rhs) noexcept;
        Constant & operator = (Constant && __rhs) noexcept;
        ~Constant();

        bool operator==(const Constant& __rhs) const noexcept;
        bool operator!=(const Constant& __rhs) const noexcept;

        void serialize(vespalib::slime::Cursor & __cursor) const;
        vespalib::string name;
        vespalib::string fileref;
        vespalib::string type;
    };
    typedef std::vector<Constant> ConstantVector;

    typedef std::map<vespalib::string, Constant> ConstantMap;

    const vespalib::string & defName() const override { return CONFIG_DEF_NAME; }
    const vespalib::string & defMd5() const override { return CONFIG_DEF_MD5; }
    const vespalib::string & defNamespace() const override { return CONFIG_DEF_NAMESPACE; }
    void serialize(::config::ConfigDataBuffer & __buffer) const override;
    InternalRankingConstantsType(const ::config::ConfigValue & __value);
    InternalRankingConstantsType(const ::config::ConfigDataBuffer & __value);
    InternalRankingConstantsType(const ::config::ConfigPayload & __payload);
    InternalRankingConstantsType() ;
    InternalRankingConstantsType(const InternalRankingConstantsType & __rhs);
    InternalRankingConstantsType & operator = (const InternalRankingConstantsType & __rhs);
    InternalRankingConstantsType(InternalRankingConstantsType && __rhs) noexcept;
    InternalRankingConstantsType & operator = (InternalRankingConstantsType && __rhs) noexcept;
    ~InternalRankingConstantsType();

    bool operator==(const InternalRankingConstantsType& __rhs) const noexcept;
    bool operator!=(const InternalRankingConstantsType& __rhs) const noexcept;

    static const vespalib::string CONFIG_DEF_MD5;
    static const vespalib::string CONFIG_DEF_NAME;
    static const vespalib::string CONFIG_DEF_NAMESPACE;
    static const ::config::StringVector CONFIG_DEF_SCHEMA;
    static const int64_t CONFIG_DEF_SERIALIZE_VERSION;

    ConstantVector constant;
};

} // namespace internal

typedef internal::InternalRankingConstantsType RankingConstantsConfigBuilder;
typedef const internal::InternalRankingConstantsType RankingConstantsConfig;

} // namespace vespa::config::search::core
#endif // VESPA_config_VESPA_CONFIG_SEARCH_CORE_RANKINGCONSTANTS_H
