/**
 * @class vespa::config::search::core::RankingExpressions
 * @ingroup config
 *
 * @brief This is an autogenerated class for handling VESPA config.
 *
 * This class is autogenerated by vespa from a config definition file.
 * To subscribe to config, you need to include the config/config.h header, 
 * and create a ConfigSubscriber in order to subscribe for config.
 *
 * Copyright Vespa.ai. Licensed under the terms of the Apache 2.0 license. See LICENSE in the project root.
 */
#ifndef CLOUD_CONFIG_VESPA_CONFIG_SEARCH_CORE_RANKINGEXPRESSIONS_H
#define CLOUD_CONFIG_VESPA_CONFIG_SEARCH_CORE_RANKINGEXPRESSIONS_H

#include <vespa/config/configgen/configinstance.h>
#include <vespa/config/common/types.h>

namespace config {
    class ConfigValue;
    class ConfigPayload;
}

namespace vespalib::slime {
    struct Inspector;
    struct Cursor;
}

namespace vespa::config::search::core {

namespace internal {

/**
 * This class contains the config. DO NOT USE THIS CLASS DIRECTLY. Use the typedeffed
 * versions after this class declaration.
 */
class InternalRankingExpressionsType : public ::config::ConfigInstance
{
public:
    typedef std::unique_ptr<const InternalRankingExpressionsType> UP;
    class Expression {
    public:
        Expression(const ::config::StringVector & __lines);
        Expression(const vespalib::slime::Inspector & __inspector);
        Expression(const ::config::ConfigPayload & __payload);
        Expression()  noexcept;
        Expression(const Expression & __rhs) noexcept;
        Expression & operator = (const Expression & __rhs) noexcept;
        Expression(Expression && __rhs) noexcept;
        Expression & operator = (Expression && __rhs) noexcept;
        ~Expression();

        bool operator==(const Expression& __rhs) const noexcept;
        bool operator!=(const Expression& __rhs) const noexcept;

        void serialize(vespalib::slime::Cursor & __cursor) const;
        vespalib::string name;
        vespalib::string fileref;
    };
    typedef std::vector<Expression> ExpressionVector;

    typedef std::map<vespalib::string, Expression> ExpressionMap;

    const vespalib::string & defName() const override { return CONFIG_DEF_NAME; }
    const vespalib::string & defMd5() const override { return CONFIG_DEF_MD5; }
    const vespalib::string & defNamespace() const override { return CONFIG_DEF_NAMESPACE; }
    void serialize(::config::ConfigDataBuffer & __buffer) const override;
    InternalRankingExpressionsType(const ::config::ConfigValue & __value);
    InternalRankingExpressionsType(const ::config::ConfigDataBuffer & __value);
    InternalRankingExpressionsType(const ::config::ConfigPayload & __payload);
    InternalRankingExpressionsType() ;
    InternalRankingExpressionsType(const InternalRankingExpressionsType & __rhs);
    InternalRankingExpressionsType & operator = (const InternalRankingExpressionsType & __rhs);
    InternalRankingExpressionsType(InternalRankingExpressionsType && __rhs) noexcept;
    InternalRankingExpressionsType & operator = (InternalRankingExpressionsType && __rhs) noexcept;
    ~InternalRankingExpressionsType();

    bool operator==(const InternalRankingExpressionsType& __rhs) const noexcept;
    bool operator!=(const InternalRankingExpressionsType& __rhs) const noexcept;

    static const vespalib::string CONFIG_DEF_MD5;
    static const vespalib::string CONFIG_DEF_NAME;
    static const vespalib::string CONFIG_DEF_NAMESPACE;
    static const ::config::StringVector CONFIG_DEF_SCHEMA;
    static const int64_t CONFIG_DEF_SERIALIZE_VERSION;

    ExpressionVector expression;
};

} // namespace internal

typedef internal::InternalRankingExpressionsType RankingExpressionsConfigBuilder;
typedef const internal::InternalRankingExpressionsType RankingExpressionsConfig;

} // namespace vespa::config::search::core
#endif // VESPA_config_VESPA_CONFIG_SEARCH_CORE_RANKINGEXPRESSIONS_H
