/**
 * @class cloud::config::Slobroks
 * @ingroup config
 *
 * @brief This is an autogenerated class for handling VESPA config.
 *
 * This class is autogenerated by vespa from a config definition file.
 * To subscribe to config, you need to include the config/config.h header, 
 * and create a ConfigSubscriber in order to subscribe for config.
 *
 * Copyright Vespa.ai. Licensed under the terms of the Apache 2.0 license. See LICENSE in the project root.
 */
#ifndef CLOUD_CONFIG_CLOUD_CONFIG_SLOBROKS_H
#define CLOUD_CONFIG_CLOUD_CONFIG_SLOBROKS_H

#include <vespa/config/configgen/configinstance.h>
#include <vespa/config/common/types.h>

namespace config {
    class ConfigValue;
    class ConfigPayload;
}

namespace vespalib::slime {
    struct Inspector;
    struct Cursor;
}

namespace cloud::config {

namespace internal {

/**
 * This class contains the config. DO NOT USE THIS CLASS DIRECTLY. Use the typedeffed
 * versions after this class declaration.
 */
class InternalSlobroksType : public ::config::ConfigInstance
{
public:
    typedef std::unique_ptr<const InternalSlobroksType> UP;
    class Slobrok {
    public:
        Slobrok(const ::config::StringVector & __lines);
        Slobrok(const vespalib::slime::Inspector & __inspector);
        Slobrok(const ::config::ConfigPayload & __payload);
        Slobrok()  noexcept;
        Slobrok(const Slobrok & __rhs) noexcept;
        Slobrok & operator = (const Slobrok & __rhs) noexcept;
        Slobrok(Slobrok && __rhs) noexcept;
        Slobrok & operator = (Slobrok && __rhs) noexcept;
        ~Slobrok();

        bool operator==(const Slobrok& __rhs) const noexcept;
        bool operator!=(const Slobrok& __rhs) const noexcept;

        void serialize(vespalib::slime::Cursor & __cursor) const;

        // Changes to this config requires restart

        /**
         * The connectionspec for a slobrok is used for connecting to it using
         * the FNET Remote Tools framework. It is normally on the form
         * tcp/hostname:portnumber where hostname is the same name returned by
         * gethostname() on the machine. This string is also used by the
         * actual slobrok to figure out which port it should listen to.
         */
        vespalib::string connectionspec;
    };
    typedef std::vector<Slobrok> SlobrokVector;

    typedef std::map<vespalib::string, Slobrok> SlobrokMap;

    const vespalib::string & defName() const override { return CONFIG_DEF_NAME; }
    const vespalib::string & defMd5() const override { return CONFIG_DEF_MD5; }
    const vespalib::string & defNamespace() const override { return CONFIG_DEF_NAMESPACE; }
    void serialize(::config::ConfigDataBuffer & __buffer) const override;
    InternalSlobroksType(const ::config::ConfigValue & __value);
    InternalSlobroksType(const ::config::ConfigDataBuffer & __value);
    InternalSlobroksType(const ::config::ConfigPayload & __payload);
    InternalSlobroksType() ;
    InternalSlobroksType(const InternalSlobroksType & __rhs);
    InternalSlobroksType & operator = (const InternalSlobroksType & __rhs);
    InternalSlobroksType(InternalSlobroksType && __rhs) noexcept;
    InternalSlobroksType & operator = (InternalSlobroksType && __rhs) noexcept;
    ~InternalSlobroksType();

    bool operator==(const InternalSlobroksType& __rhs) const noexcept;
    bool operator!=(const InternalSlobroksType& __rhs) const noexcept;

    static const vespalib::string CONFIG_DEF_MD5;
    static const vespalib::string CONFIG_DEF_NAME;
    static const vespalib::string CONFIG_DEF_NAMESPACE;
    static const ::config::StringVector CONFIG_DEF_SCHEMA;
    static const int64_t CONFIG_DEF_SERIALIZE_VERSION;

    SlobrokVector slobrok;
};

} // namespace internal

typedef internal::InternalSlobroksType SlobroksConfigBuilder;
typedef const internal::InternalSlobroksType SlobroksConfig;

} // namespace cloud::config
#endif // VESPA_config_CLOUD_CONFIG_SLOBROKS_H
