/**
 * @class vespa::config::core::Stateserver
 * @ingroup config
 *
 * @brief This is an autogenerated class for handling VESPA config.
 *
 * This class is autogenerated by vespa from a config definition file.
 * To subscribe to config, you need to include the config/config.h header, 
 * and create a ConfigSubscriber in order to subscribe for config.
 *
 * Copyright Vespa.ai. Licensed under the terms of the Apache 2.0 license. See LICENSE in the project root.
 */
#ifndef CLOUD_CONFIG_VESPA_CONFIG_CORE_STATESERVER_H
#define CLOUD_CONFIG_VESPA_CONFIG_CORE_STATESERVER_H

#include <vespa/config/configgen/configinstance.h>
#include <vespa/config/common/types.h>

namespace config {
    class ConfigValue;
    class ConfigPayload;
}

namespace vespalib::slime {
    struct Inspector;
    struct Cursor;
}

namespace vespa::config::core {

namespace internal {

/**
 * This class contains the config. DO NOT USE THIS CLASS DIRECTLY. Use the typedeffed
 * versions after this class declaration.
 */
class InternalStateserverType : public ::config::ConfigInstance
{
public:
    typedef std::unique_ptr<const InternalStateserverType> UP;
    const vespalib::string & defName() const override { return CONFIG_DEF_NAME; }
    const vespalib::string & defMd5() const override { return CONFIG_DEF_MD5; }
    const vespalib::string & defNamespace() const override { return CONFIG_DEF_NAMESPACE; }
    void serialize(::config::ConfigDataBuffer & __buffer) const override;
    InternalStateserverType(const ::config::ConfigValue & __value);
    InternalStateserverType(const ::config::ConfigDataBuffer & __value);
    InternalStateserverType(const ::config::ConfigPayload & __payload);
    InternalStateserverType()  noexcept;
    InternalStateserverType(const InternalStateserverType & __rhs) noexcept;
    InternalStateserverType & operator = (const InternalStateserverType & __rhs) noexcept;
    InternalStateserverType(InternalStateserverType && __rhs) noexcept;
    InternalStateserverType & operator = (InternalStateserverType && __rhs) noexcept;
    ~InternalStateserverType();

    bool operator==(const InternalStateserverType& __rhs) const noexcept;
    bool operator!=(const InternalStateserverType& __rhs) const noexcept;

    static const vespalib::string CONFIG_DEF_MD5;
    static const vespalib::string CONFIG_DEF_NAME;
    static const vespalib::string CONFIG_DEF_NAMESPACE;
    static const ::config::StringVector CONFIG_DEF_SCHEMA;
    static const int64_t CONFIG_DEF_SERIALIZE_VERSION;


    /** Port used for serving the state/vN api */
    int32_t httpport; // Default: 0
};

} // namespace internal

typedef internal::InternalStateserverType StateserverConfigBuilder;
typedef const internal::InternalStateserverType StateserverConfig;

} // namespace vespa::config::core
#endif // VESPA_config_VESPA_CONFIG_CORE_STATESERVER_H
