/**
 * @class cloud::config::Zookeepers
 * @ingroup config
 *
 * @brief This is an autogenerated class for handling VESPA config.
 *
 * This class is autogenerated by vespa from a config definition file.
 * To subscribe to config, you need to include the config/config.h header, 
 * and create a ConfigSubscriber in order to subscribe for config.
 *
 * Copyright Vespa.ai. Licensed under the terms of the Apache 2.0 license. See LICENSE in the project root.
 */
#ifndef CLOUD_CONFIG_CLOUD_CONFIG_ZOOKEEPERS_H
#define CLOUD_CONFIG_CLOUD_CONFIG_ZOOKEEPERS_H

#include <vespa/config/configgen/configinstance.h>
#include <vespa/config/common/types.h>

namespace config {
    class ConfigValue;
    class ConfigPayload;
}

namespace vespalib::slime {
    struct Inspector;
    struct Cursor;
}

namespace cloud::config {

namespace internal {

/**
 * This class contains the config. DO NOT USE THIS CLASS DIRECTLY. Use the typedeffed
 * versions after this class declaration.
 */
class InternalZookeepersType : public ::config::ConfigInstance
{
public:
    typedef std::unique_ptr<const InternalZookeepersType> UP;
    const vespalib::string & defName() const override { return CONFIG_DEF_NAME; }
    const vespalib::string & defMd5() const override { return CONFIG_DEF_MD5; }
    const vespalib::string & defNamespace() const override { return CONFIG_DEF_NAMESPACE; }
    void serialize(::config::ConfigDataBuffer & __buffer) const override;
    InternalZookeepersType(const ::config::ConfigValue & __value);
    InternalZookeepersType(const ::config::ConfigDataBuffer & __value);
    InternalZookeepersType(const ::config::ConfigPayload & __payload);
    InternalZookeepersType()  noexcept;
    InternalZookeepersType(const InternalZookeepersType & __rhs) noexcept;
    InternalZookeepersType & operator = (const InternalZookeepersType & __rhs) noexcept;
    InternalZookeepersType(InternalZookeepersType && __rhs) noexcept;
    InternalZookeepersType & operator = (InternalZookeepersType && __rhs) noexcept;
    ~InternalZookeepersType();

    bool operator==(const InternalZookeepersType& __rhs) const noexcept;
    bool operator!=(const InternalZookeepersType& __rhs) const noexcept;

    static const vespalib::string CONFIG_DEF_MD5;
    static const vespalib::string CONFIG_DEF_NAME;
    static const vespalib::string CONFIG_DEF_NAMESPACE;
    static const ::config::StringVector CONFIG_DEF_SCHEMA;
    static const int64_t CONFIG_DEF_SERIALIZE_VERSION;

    vespalib::string zookeeperserverlist;
};

} // namespace internal

typedef internal::InternalZookeepersType ZookeepersConfigBuilder;
typedef const internal::InternalZookeepersType ZookeepersConfig;

} // namespace cloud::config
#endif // VESPA_config_CLOUD_CONFIG_ZOOKEEPERS_H
