// A Bison parser, made by GNU Bison 3.0.4.

// Skeleton implementation for Bison LALR(1) parsers in C++

// Copyright (C) 2002-2015 Free Software Foundation, Inc.

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

// As a special exception, you may create a larger work that contains
// part or all of the Bison parser skeleton and distribute that work
// under terms of your choice, so long as that work isn't itself a
// parser generator using the skeleton or a modified version thereof
// as a parser skeleton.  Alternatively, if you modify or redistribute
// the parser skeleton itself, you may (at your option) remove this
// special exception, which will cause the skeleton and the resulting
// Bison output files to be licensed under the GNU General Public
// License without this special exception.

// This special exception was added by the Free Software Foundation in
// version 2.2 of Bison.


// First part of user declarations.

#line 37 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:404

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

#include "parser.hxx"

// User implementation prologue.

#line 51 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:412
// Unqualified %code blocks.
#line 123 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:413


// Bison has some chunky destructors that trigger inlining warnings. Disable warning
// for this translation unit, since we can't really do much about the code it generates.
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Winline"

#include <vespa/document/bucket/bucketidfactory.h>
#include <vespa/document/repo/documenttyperepo.h>
#include <vespa/document/select/scanner.h>
#include <vespa/document/select/constant.h>
#include <vespa/document/select/branch.h>
#include <vespa/document/select/compare.h>
#include <vespa/document/select/doctype.h>
#include <vespa/document/select/valuenodes.h>
#include <vespa/document/util/stringutil.h>
#include <vespa/vespalib/util/exceptions.h>
#include <string>
#include <iostream>
#include <sstream>
#include <memory>

using string = vespalib::string;

// Wrap grabbing pointers from sub-rules in a way that nulls out the
// stored attribute from the Bison stack. Otherwise, exception cleanup
// in the parser code will attempt to double-delete the pointee.
// Yes, it's not beautiful, but that's life when you're dealing with raw pointers.
template <typename T>
std::unique_ptr<T> steal(T*& ptr) noexcept {
    std::unique_ptr<T> owned(ptr);
    ptr = nullptr;
    return owned;
}

// yylex tokenization must defer to scanner instance given to parser
#undef yylex
#define yylex scanner.yylex


#line 94 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:413


#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> // FIXME: INFRINGES ON USER NAME SPACE.
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K].location)
/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

# ifndef YYLLOC_DEFAULT
#  define YYLLOC_DEFAULT(Current, Rhs, N)                               \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).begin  = YYRHSLOC (Rhs, 1).begin;                   \
          (Current).end    = YYRHSLOC (Rhs, N).end;                     \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).begin = (Current).end = YYRHSLOC (Rhs, 0).end;      \
        }                                                               \
    while (/*CONSTCOND*/ false)
# endif


// Suppress unused-variable warnings by "using" E.
#define YYUSE(E) ((void) (E))

// Enable debugging if requested.
#if YYDEBUG

// A pseudo ostream that takes yydebug_ into account.
# define YYCDEBUG if (yydebug_) (*yycdebug_)

# define YY_SYMBOL_PRINT(Title, Symbol)         \
  do {                                          \
    if (yydebug_)                               \
    {                                           \
      *yycdebug_ << Title << ' ';               \
      yy_print_ (*yycdebug_, Symbol);           \
      *yycdebug_ << std::endl;                  \
    }                                           \
  } while (false)

# define YY_REDUCE_PRINT(Rule)          \
  do {                                  \
    if (yydebug_)                       \
      yy_reduce_print_ (Rule);          \
  } while (false)

# define YY_STACK_PRINT()               \
  do {                                  \
    if (yydebug_)                       \
      yystack_print_ ();                \
  } while (false)

#else // !YYDEBUG

# define YYCDEBUG if (false) std::cerr
# define YY_SYMBOL_PRINT(Title, Symbol)  YYUSE(Symbol)
# define YY_REDUCE_PRINT(Rule)           static_cast<void>(0)
# define YY_STACK_PRINT()                static_cast<void>(0)

#endif // !YYDEBUG

#define yyerrok         (yyerrstatus_ = 0)
#define yyclearin       (yyla.clear ())

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYRECOVERING()  (!!yyerrstatus_)

#line 17 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:479
namespace document { namespace select {
#line 180 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:479

  /* Return YYSTR after stripping away unnecessary quotes and
     backslashes, so that it's suitable for yyerror.  The heuristic is
     that double-quoting is unnecessary unless the string contains an
     apostrophe, a comma, or backslash (other than backslash-backslash).
     YYSTR is taken from yytname.  */
  std::string
  DocSelParser::yytnamerr_ (const char *yystr)
  {
    if (*yystr == '"')
      {
        std::string yyr = "";
        char const *yyp = yystr;

        for (;;)
          switch (*++yyp)
            {
            case '\'':
            case ',':
              goto do_not_strip_quotes;

            case '\\':
              if (*++yyp != '\\')
                goto do_not_strip_quotes;
              // Fall through.
            default:
              yyr += *yyp;
              break;

            case '"':
              return yyr;
            }
      do_not_strip_quotes: ;
      }

    return yystr;
  }


  /// Build a parser object.
  DocSelParser::DocSelParser (DocSelScanner& scanner_yyarg, const BucketIdFactory& bucket_id_factory_yyarg, const DocumentTypeRepo& doc_type_repo_yyarg, std::unique_ptr<Node>& recv_expr_yyarg)
    :
#if YYDEBUG
      yydebug_ (false),
      yycdebug_ (&std::cerr),
#endif
      scanner (scanner_yyarg),
      bucket_id_factory (bucket_id_factory_yyarg),
      doc_type_repo (doc_type_repo_yyarg),
      recv_expr (recv_expr_yyarg)
  {}

  DocSelParser::~DocSelParser ()
  {}


  /*---------------.
  | Symbol types.  |
  `---------------*/

  inline
  DocSelParser::syntax_error::syntax_error (const location_type& l, const std::string& m)
    : std::runtime_error (m)
    , location (l)
  {}

  // basic_symbol.
  template <typename Base>
  inline
  DocSelParser::basic_symbol<Base>::basic_symbol ()
    : value ()
  {}

  template <typename Base>
  inline
  DocSelParser::basic_symbol<Base>::basic_symbol (const basic_symbol& other)
    : Base (other)
    , value ()
    , location (other.location)
  {
    value = other.value;
  }


  template <typename Base>
  inline
  DocSelParser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const semantic_type& v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}


  /// Constructor for valueless symbols.
  template <typename Base>
  inline
  DocSelParser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const location_type& l)
    : Base (t)
    , value ()
    , location (l)
  {}

  template <typename Base>
  inline
  DocSelParser::basic_symbol<Base>::~basic_symbol ()
  {
    clear ();
  }

  template <typename Base>
  inline
  void
  DocSelParser::basic_symbol<Base>::clear ()
  {
    Base::clear ();
  }

  template <typename Base>
  inline
  bool
  DocSelParser::basic_symbol<Base>::empty () const
  {
    return Base::type_get () == empty_symbol;
  }

  template <typename Base>
  inline
  void
  DocSelParser::basic_symbol<Base>::move (basic_symbol& s)
  {
    super_type::move(s);
    value = s.value;
    location = s.location;
  }

  // by_type.
  inline
  DocSelParser::by_type::by_type ()
    : type (empty_symbol)
  {}

  inline
  DocSelParser::by_type::by_type (const by_type& other)
    : type (other.type)
  {}

  inline
  DocSelParser::by_type::by_type (token_type t)
    : type (yytranslate_ (t))
  {}

  inline
  void
  DocSelParser::by_type::clear ()
  {
    type = empty_symbol;
  }

  inline
  void
  DocSelParser::by_type::move (by_type& that)
  {
    type = that.type;
    that.clear ();
  }

  inline
  int
  DocSelParser::by_type::type_get () const
  {
    return type;
  }


  // by_state.
  inline
  DocSelParser::by_state::by_state ()
    : state (empty_state)
  {}

  inline
  DocSelParser::by_state::by_state (const by_state& other)
    : state (other.state)
  {}

  inline
  void
  DocSelParser::by_state::clear ()
  {
    state = empty_state;
  }

  inline
  void
  DocSelParser::by_state::move (by_state& that)
  {
    state = that.state;
    that.clear ();
  }

  inline
  DocSelParser::by_state::by_state (state_type s)
    : state (s)
  {}

  inline
  DocSelParser::symbol_number_type
  DocSelParser::by_state::type_get () const
  {
    if (state == empty_state)
      return empty_symbol;
    else
      return yystos_[state];
  }

  inline
  DocSelParser::stack_symbol_type::stack_symbol_type ()
  {}


  inline
  DocSelParser::stack_symbol_type::stack_symbol_type (state_type s, symbol_type& that)
    : super_type (s, that.location)
  {
    value = that.value;
    // that is emptied.
    that.type = empty_symbol;
  }

  inline
  DocSelParser::stack_symbol_type&
  DocSelParser::stack_symbol_type::operator= (const stack_symbol_type& that)
  {
    state = that.state;
    value = that.value;
    location = that.location;
    return *this;
  }


  template <typename Base>
  inline
  void
  DocSelParser::yy_destroy_ (const char* yymsg, basic_symbol<Base>& yysym) const
  {
    if (yymsg)
      YY_SYMBOL_PRINT (yymsg, yysym);

    // User destructor.
    switch (yysym.type_get ())
    {
            case 28: // IDENTIFIER

#line 85 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:614
        { delete (yysym.value.string_val); }
#line 436 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:614
        break;

      case 29: // STRING

#line 85 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:614
        { delete (yysym.value.string_val); }
#line 443 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:614
        break;

      case 30: // FP_MAP_LOOKUP

#line 85 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:614
        { delete (yysym.value.string_val); }
#line 450 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:614
        break;

      case 31: // FP_ARRAY_LOOKUP

#line 85 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:614
        { delete (yysym.value.string_val); }
#line 457 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:614
        break;

      case 34: // ID

#line 86 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:614
        { delete (yysym.value.string_val); }
#line 464 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:614
        break;

      case 35: // USER

#line 86 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:614
        { delete (yysym.value.string_val); }
#line 471 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:614
        break;

      case 36: // GROUP

#line 86 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:614
        { delete (yysym.value.string_val); }
#line 478 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:614
        break;

      case 37: // SCHEME

#line 86 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:614
        { delete (yysym.value.string_val); }
#line 485 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:614
        break;

      case 38: // NAMESPACE

#line 86 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:614
        { delete (yysym.value.string_val); }
#line 492 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:614
        break;

      case 39: // SPECIFIC

#line 86 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:614
        { delete (yysym.value.string_val); }
#line 499 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:614
        break;

      case 40: // BUCKET

#line 86 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:614
        { delete (yysym.value.string_val); }
#line 506 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:614
        break;

      case 41: // GID

#line 86 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:614
        { delete (yysym.value.string_val); }
#line 513 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:614
        break;

      case 42: // TYPE

#line 86 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:614
        { delete (yysym.value.string_val); }
#line 520 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:614
        break;

      case 47: // null_

#line 87 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:614
        { delete (yysym.value.value_node); }
#line 527 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:614
        break;

      case 48: // bool_

#line 87 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:614
        { delete (yysym.value.value_node); }
#line 534 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:614
        break;

      case 49: // number

#line 87 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:614
        { delete (yysym.value.value_node); }
#line 541 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:614
        break;

      case 50: // string

#line 87 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:614
        { delete (yysym.value.value_node); }
#line 548 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:614
        break;

      case 51: // doc_type

#line 87 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:614
        { delete (yysym.value.abstract_node); }
#line 555 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:614
        break;

      case 52: // ident

#line 87 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:614
        { delete (yysym.value.string_val); }
#line 562 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:614
        break;

      case 53: // id_arg

#line 87 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:614
        { delete (yysym.value.string_val); }
#line 569 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:614
        break;

      case 54: // id_spec

#line 87 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:614
        { delete (yysym.value.value_node); }
#line 576 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:614
        break;

      case 55: // variable

#line 88 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:614
        { delete (yysym.value.value_node); }
#line 583 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:614
        break;

      case 56: // mangled_ident

#line 88 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:614
        { delete (yysym.value.string_val); }
#line 590 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:614
        break;

      case 57: // field_spec

#line 88 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:614
        { delete (yysym.value.field_expr_node); }
#line 597 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:614
        break;

      case 58: // value

#line 88 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:614
        { delete (yysym.value.value_node); }
#line 604 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:614
        break;

      case 59: // arith_expr

#line 88 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:614
        { delete (yysym.value.value_node); }
#line 611 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:614
        break;

      case 60: // comparison

#line 89 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:614
        { delete (yysym.value.abstract_node); }
#line 618 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:614
        break;

      case 61: // leaf

#line 89 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:614
        { delete (yysym.value.abstract_node); }
#line 625 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:614
        break;

      case 62: // logical_expr

#line 89 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:614
        { delete (yysym.value.abstract_node); }
#line 632 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:614
        break;

      case 63: // expression

#line 89 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:614
        { delete (yysym.value.abstract_node); }
#line 639 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:614
        break;


      default:
        break;
    }
  }

#if YYDEBUG
  template <typename Base>
  void
  DocSelParser::yy_print_ (std::ostream& yyo,
                                     const basic_symbol<Base>& yysym) const
  {
    std::ostream& yyoutput = yyo;
    YYUSE (yyoutput);
    symbol_number_type yytype = yysym.type_get ();
    // Avoid a (spurious) G++ 4.8 warning about "array subscript is
    // below array bounds".
    if (yysym.empty ())
      std::abort ();
    yyo << (yytype < yyntokens_ ? "token" : "nterm")
        << ' ' << yytname_[yytype] << " ("
        << yysym.location << ": ";
    YYUSE (yytype);
    yyo << ')';
  }
#endif

  inline
  void
  DocSelParser::yypush_ (const char* m, state_type s, symbol_type& sym)
  {
    stack_symbol_type t (s, sym);
    yypush_ (m, t);
  }

  inline
  void
  DocSelParser::yypush_ (const char* m, stack_symbol_type& s)
  {
    if (m)
      YY_SYMBOL_PRINT (m, s);
    yystack_.push (s);
  }

  inline
  void
  DocSelParser::yypop_ (unsigned int n)
  {
    yystack_.pop (n);
  }

#if YYDEBUG
  std::ostream&
  DocSelParser::debug_stream () const
  {
    return *yycdebug_;
  }

  void
  DocSelParser::set_debug_stream (std::ostream& o)
  {
    yycdebug_ = &o;
  }


  DocSelParser::debug_level_type
  DocSelParser::debug_level () const
  {
    return yydebug_;
  }

  void
  DocSelParser::set_debug_level (debug_level_type l)
  {
    yydebug_ = l;
  }
#endif // YYDEBUG

  inline DocSelParser::state_type
  DocSelParser::yy_lr_goto_state_ (state_type yystate, int yysym)
  {
    int yyr = yypgoto_[yysym - yyntokens_] + yystate;
    if (0 <= yyr && yyr <= yylast_ && yycheck_[yyr] == yystate)
      return yytable_[yyr];
    else
      return yydefgoto_[yysym - yyntokens_];
  }

  inline bool
  DocSelParser::yy_pact_value_is_default_ (int yyvalue)
  {
    return yyvalue == yypact_ninf_;
  }

  inline bool
  DocSelParser::yy_table_value_is_error_ (int yyvalue)
  {
    return yyvalue == yytable_ninf_;
  }

  int
  DocSelParser::parse ()
  {
    // State.
    int yyn;
    /// Length of the RHS of the rule being reduced.
    int yylen = 0;

    // Error handling.
    int yynerrs_ = 0;
    int yyerrstatus_ = 0;

    /// The lookahead symbol.
    symbol_type yyla;

    /// The locations where the error started and ended.
    stack_symbol_type yyerror_range[3];

    /// The return value of parse ().
    int yyresult;

    // FIXME: This shoud be completely indented.  It is not yet to
    // avoid gratuitous conflicts when merging into the master branch.
    try
      {
    YYCDEBUG << "Starting parse" << std::endl;


    /* Initialize the stack.  The initial state will be set in
       yynewstate, since the latter expects the semantical and the
       location values to have been already stored, initialize these
       stacks with a primary value.  */
    yystack_.clear ();
    yypush_ (YY_NULLPTR, 0, yyla);

    // A new symbol was pushed on the stack.
  yynewstate:
    YYCDEBUG << "Entering state " << yystack_[0].state << std::endl;

    // Accept?
    if (yystack_[0].state == yyfinal_)
      goto yyacceptlab;

    goto yybackup;

    // Backup.
  yybackup:

    // Try to take a decision without lookahead.
    yyn = yypact_[yystack_[0].state];
    if (yy_pact_value_is_default_ (yyn))
      goto yydefault;

    // Read a lookahead token.
    if (yyla.empty ())
      {
        YYCDEBUG << "Reading a token: ";
        try
          {
            yyla.type = yytranslate_ (yylex (&yyla.value, &yyla.location));
          }
        catch (const syntax_error& yyexc)
          {
            error (yyexc);
            goto yyerrlab1;
          }
      }
    YY_SYMBOL_PRINT ("Next token is", yyla);

    /* If the proper action on seeing token YYLA.TYPE is to reduce or
       to detect an error, take that action.  */
    yyn += yyla.type_get ();
    if (yyn < 0 || yylast_ < yyn || yycheck_[yyn] != yyla.type_get ())
      goto yydefault;

    // Reduce or error.
    yyn = yytable_[yyn];
    if (yyn <= 0)
      {
        if (yy_table_value_is_error_ (yyn))
          goto yyerrlab;
        yyn = -yyn;
        goto yyreduce;
      }

    // Count tokens shifted since error; after three, turn off error status.
    if (yyerrstatus_)
      --yyerrstatus_;

    // Shift the lookahead token.
    yypush_ ("Shifting", yyn, yyla);
    goto yynewstate;

  /*-----------------------------------------------------------.
  | yydefault -- do the default action for the current state.  |
  `-----------------------------------------------------------*/
  yydefault:
    yyn = yydefact_[yystack_[0].state];
    if (yyn == 0)
      goto yyerrlab;
    goto yyreduce;

  /*-----------------------------.
  | yyreduce -- Do a reduction.  |
  `-----------------------------*/
  yyreduce:
    yylen = yyr2_[yyn];
    {
      stack_symbol_type yylhs;
      yylhs.state = yy_lr_goto_state_(yystack_[yylen].state, yyr1_[yyn]);
      /* If YYLEN is nonzero, implement the default value of the
         action: '$$ = $1'.  Otherwise, use the top of the stack.

         Otherwise, the following line sets YYLHS.VALUE to garbage.
         This behavior is undocumented and Bison users should not rely
         upon it.  */
      if (yylen)
        yylhs.value = yystack_[yylen - 1].value;
      else
        yylhs.value = yystack_[0].value;

      // Compute the default @$.
      {
        slice<stack_symbol_type, stack_type> slice (yystack_, yylen);
        YYLLOC_DEFAULT (yylhs.location, slice, yylen);
      }

      // Perform the reduction.
      YY_REDUCE_PRINT (yyn);
      try
        {
          switch (yyn)
            {
  case 2:
#line 189 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:859
    { (yylhs.value.value_node) = new NullValueNode(); }
#line 878 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:859
    break;

  case 3:
#line 193 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:859
    { (yylhs.value.value_node) = new BoolValueNode(true); }
#line 884 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:859
    break;

  case 4:
#line 194 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:859
    { (yylhs.value.value_node) = new BoolValueNode(false); }
#line 890 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:859
    break;

  case 5:
#line 198 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:859
    { (yylhs.value.value_node) = new IntegerValueNode((yystack_[0].value.i64_val), false); }
#line 896 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:859
    break;

  case 6:
#line 199 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:859
    { (yylhs.value.value_node) = new FloatValueNode((yystack_[0].value.double_val)); }
#line 902 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:859
    break;

  case 7:
#line 203 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:859
    { {
          try {
              (yylhs.value.value_node) = new StringValueNode(StringUtil::unescape(*steal<string>((yystack_[0].value.string_val))));
          } catch (const vespalib::IllegalArgumentException& exc) {
              throw syntax_error(yylhs.location, exc.getMessage());
          }
     } }
#line 914 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:859
    break;

  case 8:
#line 213 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:859
    {
          if (doc_type_repo.getDocumentType(*(yystack_[0].value.string_val)) == nullptr) {
              throw syntax_error(yylhs.location, vespalib::make_string("Document type '%s' not found", (yystack_[0].value.string_val)->c_str()));
          }
          (yylhs.value.abstract_node) = new DocType(*steal<string>((yystack_[0].value.string_val)));
      }
#line 925 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:859
    break;

  case 9:
#line 223 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:859
    { (yylhs.value.string_val) = (yystack_[0].value.string_val); }
#line 931 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:859
    break;

  case 10:
#line 224 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:859
    { (yylhs.value.string_val) = (yystack_[0].value.string_val); }
#line 937 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:859
    break;

  case 11:
#line 225 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:859
    { (yylhs.value.string_val) = (yystack_[0].value.string_val); }
#line 943 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:859
    break;

  case 12:
#line 226 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:859
    { (yylhs.value.string_val) = (yystack_[0].value.string_val); }
#line 949 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:859
    break;

  case 13:
#line 227 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:859
    { (yylhs.value.string_val) = (yystack_[0].value.string_val); }
#line 955 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:859
    break;

  case 14:
#line 228 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:859
    { (yylhs.value.string_val) = (yystack_[0].value.string_val); }
#line 961 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:859
    break;

  case 15:
#line 229 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:859
    { (yylhs.value.string_val) = (yystack_[0].value.string_val); }
#line 967 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:859
    break;

  case 16:
#line 230 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:859
    { (yylhs.value.string_val) = (yystack_[0].value.string_val); }
#line 973 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:859
    break;

  case 17:
#line 231 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:859
    { (yylhs.value.string_val) = (yystack_[0].value.string_val); }
#line 979 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:859
    break;

  case 18:
#line 235 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:859
    { (yylhs.value.string_val) = (yystack_[0].value.string_val); }
#line 985 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:859
    break;

  case 19:
#line 236 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:859
    { (yylhs.value.string_val) = (yystack_[0].value.string_val); }
#line 991 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:859
    break;

  case 20:
#line 237 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:859
    { (yylhs.value.string_val) = (yystack_[0].value.string_val); }
#line 997 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:859
    break;

  case 21:
#line 238 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:859
    { (yylhs.value.string_val) = (yystack_[0].value.string_val); }
#line 1003 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:859
    break;

  case 22:
#line 239 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:859
    { (yylhs.value.string_val) = (yystack_[0].value.string_val); }
#line 1009 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:859
    break;

  case 23:
#line 240 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:859
    { (yylhs.value.string_val) = (yystack_[0].value.string_val); }
#line 1015 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:859
    break;

  case 24:
#line 241 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:859
    { (yylhs.value.string_val) = (yystack_[0].value.string_val); }
#line 1021 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:859
    break;

  case 25:
#line 242 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:859
    { (yylhs.value.string_val) = (yystack_[0].value.string_val); }
#line 1027 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:859
    break;

  case 26:
#line 246 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:859
    {
          (void)steal<string>((yystack_[0].value.string_val)); // Explicitly discard.
          (yylhs.value.value_node) = new IdValueNode(bucket_id_factory, "id", ""); // Prefer shifting instead of reducing.
      }
#line 1036 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:859
    break;

  case 27:
#line 250 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:859
    {
          (void)steal<string>((yystack_[2].value.string_val)); // Explicitly discard.
          (yylhs.value.value_node) = new IdValueNode(bucket_id_factory, "id", *steal<string>((yystack_[0].value.string_val)));
      }
#line 1045 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:859
    break;

  case 28:
#line 254 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:859
    {
          (void)steal<string>((yystack_[4].value.string_val));  // Explicitly discard.
          (yylhs.value.value_node) = new FunctionValueNode(*steal<string>((yystack_[2].value.string_val)), std::make_unique<IdValueNode>(bucket_id_factory, "id", ""));
      }
#line 1054 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:859
    break;

  case 29:
#line 261 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:859
    { (yylhs.value.value_node) = new VariableValueNode(*steal<string>((yystack_[0].value.string_val))); }
#line 1060 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:859
    break;

  case 30:
#line 272 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:859
    { (yylhs.value.string_val) = (yystack_[0].value.string_val); }
#line 1066 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:859
    break;

  case 31:
#line 273 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:859
    { (yystack_[1].value.string_val)->append(*steal<string>((yystack_[0].value.string_val))); (yylhs.value.string_val) = (yystack_[1].value.string_val); }
#line 1072 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:859
    break;

  case 32:
#line 274 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:859
    { (yystack_[1].value.string_val)->append(*steal<string>((yystack_[0].value.string_val))); (yylhs.value.string_val) = (yystack_[1].value.string_val); }
#line 1078 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:859
    break;

  case 33:
#line 275 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:859
    { (yylhs.value.string_val) = (yystack_[0].value.string_val); }
#line 1084 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:859
    break;

  case 34:
#line 279 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:859
    {
          if (doc_type_repo.getDocumentType(*(yystack_[2].value.string_val)) == nullptr) {
              throw syntax_error(yylhs.location, vespalib::make_string("Document type '%s' not found", (yystack_[2].value.string_val)->c_str()));
          }
          (yylhs.value.field_expr_node) = new FieldExprNode(std::make_unique<FieldExprNode>(*steal<string>((yystack_[2].value.string_val))), *steal<string>((yystack_[0].value.string_val)));
      }
#line 1095 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:859
    break;

  case 35:
#line 285 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:859
    { (yylhs.value.field_expr_node) = new FieldExprNode(steal<FieldExprNode>((yystack_[2].value.field_expr_node)), *steal<string>((yystack_[0].value.string_val))); }
#line 1101 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:859
    break;

  case 36:
#line 289 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:859
    { (yylhs.value.value_node) = (yystack_[0].value.value_node); }
#line 1107 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:859
    break;

  case 37:
#line 290 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:859
    { (yylhs.value.value_node) = (yystack_[0].value.value_node); }
#line 1113 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:859
    break;

  case 38:
#line 291 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:859
    { (yylhs.value.value_node) = (yystack_[0].value.value_node); }
#line 1119 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:859
    break;

  case 39:
#line 292 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:859
    { (yylhs.value.value_node) = (yystack_[0].value.value_node); }
#line 1125 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:859
    break;

  case 40:
#line 293 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:859
    { (yylhs.value.value_node) = (yystack_[0].value.value_node); }
#line 1131 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:859
    break;

  case 41:
#line 294 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:859
    { (yylhs.value.value_node) = new CurrentTimeValueNode(); }
#line 1137 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:859
    break;

  case 42:
#line 298 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:859
    { (yylhs.value.value_node) = (yystack_[0].value.value_node); }
#line 1143 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:859
    break;

  case 43:
#line 299 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:859
    { (yylhs.value.value_node) = (yystack_[0].value.value_node); }
#line 1149 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:859
    break;

  case 44:
#line 301 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:859
    {
          if (dynamic_cast<IntegerValueNode*>((yystack_[0].value.value_node)) != nullptr) {
              (yylhs.value.value_node) = new IntegerValueNode(- static_cast<IntegerValueNode&>(*steal<ValueNode>((yystack_[0].value.value_node))).getValue(), false);
          } else {
              (yylhs.value.value_node) = new FloatValueNode(- dynamic_cast<FloatValueNode&>(*steal<ValueNode>((yystack_[0].value.value_node))).getValue());
          }
      }
#line 1161 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:859
    break;

  case 45:
#line 308 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:859
    { (yylhs.value.value_node) = (yystack_[0].value.value_node); }
#line 1167 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:859
    break;

  case 46:
#line 309 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:859
    { (yylhs.value.value_node) = steal<FieldExprNode>((yystack_[0].value.field_expr_node))->convert_to_field_value().release(); }
#line 1173 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:859
    break;

  case 47:
#line 310 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:859
    { (yylhs.value.value_node) = steal<FieldExprNode>((yystack_[2].value.field_expr_node))->convert_to_function_call().release(); }
#line 1179 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:859
    break;

  case 48:
#line 311 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:859
    { (yylhs.value.value_node) = new ArithmeticValueNode(steal<ValueNode>((yystack_[2].value.value_node)), "+", steal<ValueNode>((yystack_[0].value.value_node))); }
#line 1185 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:859
    break;

  case 49:
#line 312 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:859
    { (yylhs.value.value_node) = new ArithmeticValueNode(steal<ValueNode>((yystack_[2].value.value_node)), "-", steal<ValueNode>((yystack_[0].value.value_node))); }
#line 1191 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:859
    break;

  case 50:
#line 313 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:859
    { (yylhs.value.value_node) = new ArithmeticValueNode(steal<ValueNode>((yystack_[2].value.value_node)), "*", steal<ValueNode>((yystack_[0].value.value_node))); }
#line 1197 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:859
    break;

  case 51:
#line 314 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:859
    { (yylhs.value.value_node) = new ArithmeticValueNode(steal<ValueNode>((yystack_[2].value.value_node)), "/", steal<ValueNode>((yystack_[0].value.value_node))); }
#line 1203 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:859
    break;

  case 52:
#line 315 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:859
    { (yylhs.value.value_node) = new ArithmeticValueNode(steal<ValueNode>((yystack_[2].value.value_node)), "%", steal<ValueNode>((yystack_[0].value.value_node))); }
#line 1209 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:859
    break;

  case 53:
#line 316 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:859
    { (yylhs.value.value_node) = (yystack_[1].value.value_node); (yylhs.value.value_node)->setParentheses(); }
#line 1215 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:859
    break;

  case 54:
#line 317 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:859
    { (yylhs.value.value_node) = new FunctionValueNode(*steal<string>((yystack_[2].value.string_val)), steal<ValueNode>((yystack_[4].value.value_node))); }
#line 1221 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:859
    break;

  case 55:
#line 321 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:859
    { (yylhs.value.abstract_node) = new Compare(steal<ValueNode>((yystack_[2].value.value_node)), FunctionOperator::EQ, steal<ValueNode>((yystack_[0].value.value_node)), bucket_id_factory); }
#line 1227 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:859
    break;

  case 56:
#line 322 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:859
    { (yylhs.value.abstract_node) = new Compare(steal<ValueNode>((yystack_[2].value.value_node)), FunctionOperator::NE, steal<ValueNode>((yystack_[0].value.value_node)), bucket_id_factory); }
#line 1233 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:859
    break;

  case 57:
#line 323 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:859
    { (yylhs.value.abstract_node) = new Compare(steal<ValueNode>((yystack_[2].value.value_node)), FunctionOperator::GEQ, steal<ValueNode>((yystack_[0].value.value_node)), bucket_id_factory); }
#line 1239 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:859
    break;

  case 58:
#line 324 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:859
    { (yylhs.value.abstract_node) = new Compare(steal<ValueNode>((yystack_[2].value.value_node)), FunctionOperator::LEQ, steal<ValueNode>((yystack_[0].value.value_node)), bucket_id_factory); }
#line 1245 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:859
    break;

  case 59:
#line 325 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:859
    { (yylhs.value.abstract_node) = new Compare(steal<ValueNode>((yystack_[2].value.value_node)), FunctionOperator::GT, steal<ValueNode>((yystack_[0].value.value_node)), bucket_id_factory); }
#line 1251 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:859
    break;

  case 60:
#line 326 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:859
    { (yylhs.value.abstract_node) = new Compare(steal<ValueNode>((yystack_[2].value.value_node)), FunctionOperator::LT, steal<ValueNode>((yystack_[0].value.value_node)), bucket_id_factory); }
#line 1257 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:859
    break;

  case 61:
#line 327 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:859
    { (yylhs.value.abstract_node) = new Compare(steal<ValueNode>((yystack_[2].value.value_node)), GlobOperator::GLOB, steal<ValueNode>((yystack_[0].value.value_node)), bucket_id_factory); }
#line 1263 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:859
    break;

  case 62:
#line 328 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:859
    { (yylhs.value.abstract_node) = new Compare(steal<ValueNode>((yystack_[2].value.value_node)), RegexOperator::REGEX, steal<ValueNode>((yystack_[0].value.value_node)), bucket_id_factory); }
#line 1269 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:859
    break;

  case 63:
#line 332 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:859
    { (yylhs.value.abstract_node) = (yystack_[0].value.abstract_node); }
#line 1275 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:859
    break;

  case 64:
#line 333 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:859
    { (yylhs.value.abstract_node) = (yystack_[0].value.abstract_node); }
#line 1281 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:859
    break;

  case 65:
#line 334 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:859
    { /* Actually bool_ or field_spec, see comment below..! */
          // Grammar-wise, we _do not_ accept arbitrary arith_exprs at this level. But the
          // selection grammar as it stands is otherwise ambiguous with LR(1) parsing.
          // More specifically, if we used field_spec instead of arith_expr here, the parser
          // state machine cannot decide what to do if it has processed the sequence '(' field_spec
          // and sees the next token of ')'. Since both logical_expr and arith_expr allows for
          // parenthesis expression recursion, the reduce step may produce either of these and
          // is therefore technically undefined. By using arith_expr instead for this rule, all
          // '(' field_spec ')' sequences result in an arith_expr rule match and the reduce/reduce
          // conflict goes away. We can then do a sneaky "run-time" type check to ensure we only
          // get the expected node from the rule.
          // It's not pretty, but it avoids an undefined grammar (which is much less pretty!).
          // The same goes for boolean constants, which may be used both as higher-level (non-value)
          // nodes or as value nodes to compare against.
          auto node = steal<ValueNode>((yystack_[0].value.value_node));
          if (auto* as_bool = dynamic_cast<BoolValueNode*>(node.get())) {
              (yylhs.value.abstract_node) = new Constant(as_bool->bool_value()); // Replace single bool node subtree with constant.
          } else {
              if (dynamic_cast<FieldValueNode*>(node.get()) == nullptr) {
                  throw syntax_error(yylhs.location, "expected field spec, doctype, bool or comparison");
              }
              // Implicit rewrite to non-null comparison node
              (yylhs.value.abstract_node) = new Compare(std::move(node),
                               FunctionOperator::NE,
                               std::make_unique<NullValueNode>(),
                               bucket_id_factory);
          }
      }
#line 1314 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:859
    break;

  case 66:
#line 365 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:859
    { (yylhs.value.abstract_node) = (yystack_[0].value.abstract_node); }
#line 1320 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:859
    break;

  case 67:
#line 366 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:859
    { (yylhs.value.abstract_node) = new And(steal<Node>((yystack_[2].value.abstract_node)), steal<Node>((yystack_[0].value.abstract_node))); }
#line 1326 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:859
    break;

  case 68:
#line 367 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:859
    { (yylhs.value.abstract_node) = new Or(steal<Node>((yystack_[2].value.abstract_node)), steal<Node>((yystack_[0].value.abstract_node))); }
#line 1332 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:859
    break;

  case 69:
#line 368 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:859
    { (yylhs.value.abstract_node) = new Not(steal<Node>((yystack_[0].value.abstract_node))); }
#line 1338 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:859
    break;

  case 70:
#line 369 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:859
    { (yylhs.value.abstract_node) = (yystack_[1].value.abstract_node); (yylhs.value.abstract_node)->setParentheses(); }
#line 1344 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:859
    break;

  case 71:
#line 373 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:859
    { (yylhs.value.abstract_node) = (yystack_[0].value.abstract_node); }
#line 1350 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:859
    break;

  case 72:
#line 377 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:859
    { recv_expr = steal<Node>((yystack_[1].value.abstract_node)); }
#line 1356 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:859
    break;

  case 73:
#line 378 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:859
    { recv_expr = std::make_unique<Constant>(true); }
#line 1362 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:859
    break;


#line 1366 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:859
            default:
              break;
            }
        }
      catch (const syntax_error& yyexc)
        {
          error (yyexc);
          YYERROR;
        }
      YY_SYMBOL_PRINT ("-> $$ =", yylhs);
      yypop_ (yylen);
      yylen = 0;
      YY_STACK_PRINT ();

      // Shift the result of the reduction.
      yypush_ (YY_NULLPTR, yylhs);
    }
    goto yynewstate;

  /*--------------------------------------.
  | yyerrlab -- here on detecting error.  |
  `--------------------------------------*/
  yyerrlab:
    // If not already recovering from an error, report this error.
    if (!yyerrstatus_)
      {
        ++yynerrs_;
        error (yyla.location, yysyntax_error_ (yystack_[0].state, yyla));
      }


    yyerror_range[1].location = yyla.location;
    if (yyerrstatus_ == 3)
      {
        /* If just tried and failed to reuse lookahead token after an
           error, discard it.  */

        // Return failure if at end of input.
        if (yyla.type_get () == yyeof_)
          YYABORT;
        else if (!yyla.empty ())
          {
            yy_destroy_ ("Error: discarding", yyla);
            yyla.clear ();
          }
      }

    // Else will try to reuse lookahead token after shifting the error token.
    goto yyerrlab1;


  /*---------------------------------------------------.
  | yyerrorlab -- error raised explicitly by YYERROR.  |
  `---------------------------------------------------*/
  yyerrorlab:

    /* Pacify compilers like GCC when the user code never invokes
       YYERROR and the label yyerrorlab therefore never appears in user
       code.  */
    if (false)
      goto yyerrorlab;
    yyerror_range[1].location = yystack_[yylen - 1].location;
    /* Do not reclaim the symbols of the rule whose action triggered
       this YYERROR.  */
    yypop_ (yylen);
    yylen = 0;
    goto yyerrlab1;

  /*-------------------------------------------------------------.
  | yyerrlab1 -- common code for both syntax error and YYERROR.  |
  `-------------------------------------------------------------*/
  yyerrlab1:
    yyerrstatus_ = 3;   // Each real token shifted decrements this.
    {
      stack_symbol_type error_token;
      for (;;)
        {
          yyn = yypact_[yystack_[0].state];
          if (!yy_pact_value_is_default_ (yyn))
            {
              yyn += yyterror_;
              if (0 <= yyn && yyn <= yylast_ && yycheck_[yyn] == yyterror_)
                {
                  yyn = yytable_[yyn];
                  if (0 < yyn)
                    break;
                }
            }

          // Pop the current state because it cannot handle the error token.
          if (yystack_.size () == 1)
            YYABORT;

          yyerror_range[1].location = yystack_[0].location;
          yy_destroy_ ("Error: popping", yystack_[0]);
          yypop_ ();
          YY_STACK_PRINT ();
        }

      yyerror_range[2].location = yyla.location;
      YYLLOC_DEFAULT (error_token.location, yyerror_range, 2);

      // Shift the error token.
      error_token.state = yyn;
      yypush_ ("Shifting", error_token);
    }
    goto yynewstate;

    // Accept.
  yyacceptlab:
    yyresult = 0;
    goto yyreturn;

    // Abort.
  yyabortlab:
    yyresult = 1;
    goto yyreturn;

  yyreturn:
    if (!yyla.empty ())
      yy_destroy_ ("Cleanup: discarding lookahead", yyla);

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYABORT or YYACCEPT.  */
    yypop_ (yylen);
    while (1 < yystack_.size ())
      {
        yy_destroy_ ("Cleanup: popping", yystack_[0]);
        yypop_ ();
      }

    return yyresult;
  }
    catch (...)
      {
        YYCDEBUG << "Exception caught: cleaning lookahead and stack"
                 << std::endl;
        // Do not try to display the values of the reclaimed symbols,
        // as their printer might throw an exception.
        if (!yyla.empty ())
          yy_destroy_ (YY_NULLPTR, yyla);

        while (1 < yystack_.size ())
          {
            yy_destroy_ (YY_NULLPTR, yystack_[0]);
            yypop_ ();
          }
        throw;
      }
  }

  void
  DocSelParser::error (const syntax_error& yyexc)
  {
    error (yyexc.location, yyexc.what());
  }

  // Generate an error message.
  std::string
  DocSelParser::yysyntax_error_ (state_type yystate, const symbol_type& yyla) const
  {
    // Number of reported tokens (one for the "unexpected", one per
    // "expected").
    size_t yycount = 0;
    // Its maximum.
    enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
    // Arguments of yyformat.
    char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];

    /* There are many possibilities here to consider:
       - If this state is a consistent state with a default action, then
         the only way this function was invoked is if the default action
         is an error action.  In that case, don't check for expected
         tokens because there are none.
       - The only way there can be no lookahead present (in yyla) is
         if this state is a consistent state with a default action.
         Thus, detecting the absence of a lookahead is sufficient to
         determine that there is no unexpected or expected token to
         report.  In that case, just report a simple "syntax error".
       - Don't assume there isn't a lookahead just because this state is
         a consistent state with a default action.  There might have
         been a previous inconsistent state, consistent state with a
         non-default action, or user semantic action that manipulated
         yyla.  (However, yyla is currently not documented for users.)
       - Of course, the expected token list depends on states to have
         correct lookahead information, and it depends on the parser not
         to perform extra reductions after fetching a lookahead from the
         scanner and before detecting a syntax error.  Thus, state
         merging (from LALR or IELR) and default reductions corrupt the
         expected token list.  However, the list is correct for
         canonical LR with one exception: it will still contain any
         token that will not be accepted due to an error action in a
         later state.
    */
    if (!yyla.empty ())
      {
        int yytoken = yyla.type_get ();
        yyarg[yycount++] = yytname_[yytoken];
        int yyn = yypact_[yystate];
        if (!yy_pact_value_is_default_ (yyn))
          {
            /* Start YYX at -YYN if negative to avoid negative indexes in
               YYCHECK.  In other words, skip the first -YYN actions for
               this state because they are default actions.  */
            int yyxbegin = yyn < 0 ? -yyn : 0;
            // Stay within bounds of both yycheck and yytname.
            int yychecklim = yylast_ - yyn + 1;
            int yyxend = yychecklim < yyntokens_ ? yychecklim : yyntokens_;
            for (int yyx = yyxbegin; yyx < yyxend; ++yyx)
              if (yycheck_[yyx + yyn] == yyx && yyx != yyterror_
                  && !yy_table_value_is_error_ (yytable_[yyx + yyn]))
                {
                  if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                    {
                      yycount = 1;
                      break;
                    }
                  else
                    yyarg[yycount++] = yytname_[yyx];
                }
          }
      }

    char const* yyformat = YY_NULLPTR;
    switch (yycount)
      {
#define YYCASE_(N, S)                         \
        case N:                               \
          yyformat = S;                       \
        break
        YYCASE_(0, YY_("syntax error"));
        YYCASE_(1, YY_("syntax error, unexpected %s"));
        YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
        YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
        YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
        YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
      }

    std::string yyres;
    // Argument number.
    size_t yyi = 0;
    for (char const* yyp = yyformat; *yyp; ++yyp)
      if (yyp[0] == '%' && yyp[1] == 's' && yyi < yycount)
        {
          yyres += yytnamerr_ (yyarg[yyi++]);
          ++yyp;
        }
      else
        yyres += *yyp;
    return yyres;
  }


  const signed char DocSelParser::yypact_ninf_ = -28;

  const signed char DocSelParser::yytable_ninf_ = -1;

  const short int
  DocSelParser::yypact_[] =
  {
      62,   -28,   -28,   -28,   -28,   102,   -28,   185,   102,   -27,
     -27,   -28,   -28,   -28,   -28,   -16,   -28,   -28,   -28,   -28,
     -28,   -28,   -28,   -28,   -28,   -28,   -28,   -28,   -28,    -1,
     -28,   -28,   -12,   -28,   176,   -28,   -28,    52,    11,    15,
     -28,   -28,    10,     6,   -28,   -28,   200,   170,   170,     7,
     142,   142,   142,   142,   142,   142,   142,   142,     2,   142,
     142,   142,   142,   142,   102,   102,   -28,   -28,   -28,   -28,
      21,   -28,   -28,   -28,   -28,   -28,   -28,   -28,   -28,   -28,
     -28,   -28,    33,    33,   -28,   142,    -1,   129,   129,   129,
     129,   129,   129,   129,   129,    30,    13,    13,   -17,   -17,
      53,   -28,    65,    54,   -28,   -28,    90,    55,   -28,   -28
  };

  const unsigned char
  DocSelParser::yydefact_[] =
  {
       0,    73,     2,     3,     4,     0,    41,     0,     0,     0,
       0,     9,     7,     6,     5,    26,    10,    11,    12,    14,
      15,    16,    17,    13,    36,    37,    43,    38,    64,     8,
      39,    40,    46,    42,    65,    63,    66,    71,     0,     0,
      69,    29,    65,     0,    45,    44,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    72,     1,    53,    70,
       0,    18,    19,    20,    21,    22,    23,    24,    25,    27,
      33,    30,    34,    35,    47,     0,     0,    61,    62,    55,
      56,    57,    58,    59,    60,     0,    48,    49,    50,    51,
      52,    67,    68,     0,    31,    32,     0,     0,    28,    54
  };

  const signed char
  DocSelParser::yypgoto_[] =
  {
     -28,   -28,   -28,    59,   -28,   -28,     9,   -28,   -28,   -28,
      35,   -28,   -28,    -8,   -28,   -28,    -4,   -28,   -28
  };

  const signed char
  DocSelParser::yydefgoto_[] =
  {
      -1,    24,    25,    26,    27,    28,    86,    79,    30,    31,
      82,    32,    33,    34,    35,    36,    37,    38,    39
  };

  const unsigned char
  DocSelParser::yytable_[] =
  {
      42,    40,    58,    46,    43,    13,    14,    48,    49,    29,
      63,    66,    64,    65,    29,    67,    41,    29,    47,    50,
      51,    52,    53,    54,    55,    56,    57,    69,    84,    58,
      95,    68,    58,    59,    60,    61,    62,    63,    61,    62,
      63,   103,    87,    88,    89,    90,    91,    92,    93,    94,
     107,    96,    97,    98,    99,   100,    81,    81,    64,    65,
     101,   102,     1,   104,   105,     2,     3,     4,    44,    45,
       5,    64,    58,    29,    29,   108,   109,   106,     0,     6,
       7,     0,     8,    83,     0,     9,    10,     0,     0,     0,
      11,    12,     0,     0,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,     2,     3,     4,     0,    58,
       5,    68,     0,    59,    60,    61,    62,    63,     0,     6,
       7,     0,     8,     0,     0,     9,    10,     0,     0,     0,
      11,    12,     0,     0,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,     2,     3,     4,    58,     0,
       0,     0,    59,    60,    61,    62,    63,     0,     0,     6,
       7,     0,    85,     0,     0,     9,    10,     0,     0,     0,
      11,    12,     0,     0,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    50,    51,    52,    53,    54,
      55,    56,    57,     0,     0,    58,     0,     0,    11,    59,
      60,    61,    62,    63,    80,    16,    17,    18,    19,    20,
      21,    22,    23,    11,     0,     0,     0,     0,     0,     0,
      16,    17,    18,    19,    20,    21,    22,    23,    70,     0,
       0,     0,     0,     0,     0,    71,    72,    73,    74,    75,
      76,    77,    78
  };

  const signed char
  DocSelParser::yycheck_[] =
  {
       8,     5,    19,    19,     8,    32,    33,    19,    20,     0,
      27,     0,     6,     7,     5,     0,     7,     8,    19,     9,
      10,    11,    12,    13,    14,    15,    16,    21,    21,    19,
      28,    21,    19,    23,    24,    25,    26,    27,    25,    26,
      27,    20,    50,    51,    52,    53,    54,    55,    56,    57,
      20,    59,    60,    61,    62,    63,    47,    48,     6,     7,
      64,    65,     0,    30,    31,     3,     4,     5,     9,    10,
       8,     6,    19,    64,    65,    21,    21,    85,    -1,    17,
      18,    -1,    20,    48,    -1,    23,    24,    -1,    -1,    -1,
      28,    29,    -1,    -1,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,     3,     4,     5,    -1,    19,
       8,    21,    -1,    23,    24,    25,    26,    27,    -1,    17,
      18,    -1,    20,    -1,    -1,    23,    24,    -1,    -1,    -1,
      28,    29,    -1,    -1,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,     3,     4,     5,    19,    -1,
      -1,    -1,    23,    24,    25,    26,    27,    -1,    -1,    17,
      18,    -1,    20,    -1,    -1,    23,    24,    -1,    -1,    -1,
      28,    29,    -1,    -1,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,     9,    10,    11,    12,    13,
      14,    15,    16,    -1,    -1,    19,    -1,    -1,    28,    23,
      24,    25,    26,    27,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    28,    -1,    -1,    -1,    -1,    -1,    -1,
      35,    36,    37,    38,    39,    40,    41,    42,    28,    -1,
      -1,    -1,    -1,    -1,    -1,    35,    36,    37,    38,    39,
      40,    41,    42
  };

  const unsigned char
  DocSelParser::yystos_[] =
  {
       0,     0,     3,     4,     5,     8,    17,    18,    20,    23,
      24,    28,    29,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    41,    42,    47,    48,    49,    50,    51,    52,
      54,    55,    57,    58,    59,    60,    61,    62,    63,    64,
      62,    52,    59,    62,    49,    49,    19,    19,    19,    20,
       9,    10,    11,    12,    13,    14,    15,    16,    19,    23,
      24,    25,    26,    27,     6,     7,     0,     0,    21,    21,
      28,    35,    36,    37,    38,    39,    40,    41,    42,    53,
      34,    52,    56,    56,    21,    20,    52,    59,    59,    59,
      59,    59,    59,    59,    59,    28,    59,    59,    59,    59,
      59,    62,    62,    20,    30,    31,    59,    20,    21,    21
  };

  const unsigned char
  DocSelParser::yyr1_[] =
  {
       0,    46,    47,    48,    48,    49,    49,    50,    51,    52,
      52,    52,    52,    52,    52,    52,    52,    52,    53,    53,
      53,    53,    53,    53,    53,    53,    54,    54,    54,    55,
      56,    56,    56,    56,    57,    57,    58,    58,    58,    58,
      58,    58,    59,    59,    59,    59,    59,    59,    59,    59,
      59,    59,    59,    59,    59,    60,    60,    60,    60,    60,
      60,    60,    60,    61,    61,    61,    62,    62,    62,    62,
      62,    63,    64,    64
  };

  const unsigned char
  DocSelParser::yyr2_[] =
  {
       0,     2,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     3,     5,     2,
       1,     2,     2,     1,     3,     3,     1,     1,     1,     1,
       1,     1,     1,     1,     2,     2,     1,     3,     3,     3,
       3,     3,     3,     3,     5,     3,     3,     3,     3,     3,
       3,     3,     3,     1,     1,     1,     1,     3,     3,     2,
       3,     1,     2,     1
  };



  // YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
  // First, the terminals, then, starting at \a yyntokens_, nonterminals.
  const char*
  const DocSelParser::yytname_[] =
  {
  "\"end of input\"", "error", "$undefined", "NULL", "TRUE", "FALSE",
  "AND", "OR", "NOT", "\"=\"", "\"=~\"", "\"==\"", "\"!=\"", "\">=\"",
  "\"<=\"", "\">\"", "\"<\"", "NOW_FUNC", "\"$\"", "\".\"", "\"(\"",
  "\")\"", "\",\"", "\"+\"", "\"-\"", "\"*\"", "\"/\"", "\"%\"",
  "IDENTIFIER", "STRING", "FP_MAP_LOOKUP", "FP_ARRAY_LOOKUP", "FLOAT",
  "INTEGER", "ID", "USER", "GROUP", "SCHEME", "NAMESPACE", "SPECIFIC",
  "BUCKET", "GID", "TYPE", "NEG", "UNOT", "NON_DOT", "$accept", "null_",
  "bool_", "number", "string", "doc_type", "ident", "id_arg", "id_spec",
  "variable", "mangled_ident", "field_spec", "value", "arith_expr",
  "comparison", "leaf", "logical_expr", "expression", "entry", YY_NULLPTR
  };

#if YYDEBUG
  const unsigned short int
  DocSelParser::yyrline_[] =
  {
       0,   189,   189,   193,   194,   198,   199,   203,   213,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   235,   236,
     237,   238,   239,   240,   241,   242,   246,   250,   254,   261,
     272,   273,   274,   275,   279,   285,   289,   290,   291,   292,
     293,   294,   298,   299,   301,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   321,   322,   323,   324,   325,
     326,   327,   328,   332,   333,   334,   365,   366,   367,   368,
     369,   373,   377,   378
  };

  // Print the state stack on the debug stream.
  void
  DocSelParser::yystack_print_ ()
  {
    *yycdebug_ << "Stack now";
    for (stack_type::const_iterator
           i = yystack_.begin (),
           i_end = yystack_.end ();
         i != i_end; ++i)
      *yycdebug_ << ' ' << i->state;
    *yycdebug_ << std::endl;
  }

  // Report on the debug stream that the rule \a yyrule is going to be reduced.
  void
  DocSelParser::yy_reduce_print_ (int yyrule)
  {
    unsigned int yylno = yyrline_[yyrule];
    int yynrhs = yyr2_[yyrule];
    // Print the symbols being reduced, and their result.
    *yycdebug_ << "Reducing stack by rule " << yyrule - 1
               << " (line " << yylno << "):" << std::endl;
    // The symbols being reduced.
    for (int yyi = 0; yyi < yynrhs; yyi++)
      YY_SYMBOL_PRINT ("   $" << yyi + 1 << " =",
                       yystack_[(yynrhs) - (yyi + 1)]);
  }
#endif // YYDEBUG

  // Symbol number corresponding to token number t.
  inline
  DocSelParser::token_number_type
  DocSelParser::yytranslate_ (int t)
  {
    static
    const token_number_type
    translate_table[] =
    {
     0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45
    };
    const unsigned int user_token_number_max_ = 300;
    const token_number_type undef_token_ = 2;

    if (static_cast<int>(t) <= yyeof_)
      return yyeof_;
    else if (static_cast<unsigned int> (t) <= user_token_number_max_)
      return translate_table[t];
    else
      return undef_token_;
  }

#line 17 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:1167
} } // document::select
#line 1889 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/parser.cxx" // lalr1.cc:1167
#line 381 "/builddir/build/BUILD/vespa-8.363.17/document/src/vespa/document/select/grammar/parser.yy" // lalr1.cc:1168


void document::select::DocSelParser::error(const location_type& l, const std::string& what) {
    throw syntax_error(l, what);
}

void throw_parser_syntax_error(const document::select::DocSelParser::location_type& loc, const std::string& msg) {
    throw document::select::DocSelParser::syntax_error(loc, msg);
}

#pragma GCC diagnostic pop
