/**
 * @class documentapi::messagebus::protocol::Documentrouteselectorpolicy
 * @ingroup config
 *
 * @brief This is an autogenerated class for handling VESPA config.
 *
 * This class is autogenerated by vespa from a config definition file.
 * To subscribe to config, you need to include the config/config.h header, 
 * and create a ConfigSubscriber in order to subscribe for config.
 *
 * Copyright Vespa.ai. Licensed under the terms of the Apache 2.0 license. See LICENSE in the project root.
 */
#ifndef CLOUD_CONFIG_DOCUMENTAPI_MESSAGEBUS_PROTOCOL_DOCUMENTROUTESELECTORPOLICY_H
#define CLOUD_CONFIG_DOCUMENTAPI_MESSAGEBUS_PROTOCOL_DOCUMENTROUTESELECTORPOLICY_H

#include <vespa/config/configgen/configinstance.h>
#include <vespa/config/common/types.h>

namespace config {
    class ConfigValue;
    class ConfigPayload;
}

namespace vespalib::slime {
    struct Inspector;
    struct Cursor;
}

namespace documentapi::messagebus::protocol {

namespace internal {

/**
 * This class contains the config. DO NOT USE THIS CLASS DIRECTLY. Use the typedeffed
 * versions after this class declaration.
 */
class InternalDocumentrouteselectorpolicyType : public ::config::ConfigInstance
{
public:
    typedef std::unique_ptr<const InternalDocumentrouteselectorpolicyType> UP;
    class Route {
    public:
        Route(const ::config::StringVector & __lines);
        Route(const vespalib::slime::Inspector & __inspector);
        Route(const ::config::ConfigPayload & __payload);
        Route()  noexcept;
        Route(const Route & __rhs) noexcept;
        Route & operator = (const Route & __rhs) noexcept;
        Route(Route && __rhs) noexcept;
        Route & operator = (Route && __rhs) noexcept;
        ~Route();

        bool operator==(const Route& __rhs) const noexcept;
        bool operator!=(const Route& __rhs) const noexcept;

        void serialize(vespalib::slime::Cursor & __cursor) const;

        /** The name of the route. */
        vespalib::string name;

        /** The document selector for this route. */
        vespalib::string selector;

        /** The feeds that this route accepts. */
        vespalib::string feed; // Default: ""
    };
    typedef std::vector<Route> RouteVector;

    typedef std::map<vespalib::string, Route> RouteMap;

    const vespalib::string & defName() const override { return CONFIG_DEF_NAME; }
    const vespalib::string & defMd5() const override { return CONFIG_DEF_MD5; }
    const vespalib::string & defNamespace() const override { return CONFIG_DEF_NAMESPACE; }
    void serialize(::config::ConfigDataBuffer & __buffer) const override;
    InternalDocumentrouteselectorpolicyType(const ::config::ConfigValue & __value);
    InternalDocumentrouteselectorpolicyType(const ::config::ConfigDataBuffer & __value);
    InternalDocumentrouteselectorpolicyType(const ::config::ConfigPayload & __payload);
    InternalDocumentrouteselectorpolicyType() ;
    InternalDocumentrouteselectorpolicyType(const InternalDocumentrouteselectorpolicyType & __rhs);
    InternalDocumentrouteselectorpolicyType & operator = (const InternalDocumentrouteselectorpolicyType & __rhs);
    InternalDocumentrouteselectorpolicyType(InternalDocumentrouteselectorpolicyType && __rhs) noexcept;
    InternalDocumentrouteselectorpolicyType & operator = (InternalDocumentrouteselectorpolicyType && __rhs) noexcept;
    ~InternalDocumentrouteselectorpolicyType();

    bool operator==(const InternalDocumentrouteselectorpolicyType& __rhs) const noexcept;
    bool operator!=(const InternalDocumentrouteselectorpolicyType& __rhs) const noexcept;

    static const vespalib::string CONFIG_DEF_MD5;
    static const vespalib::string CONFIG_DEF_NAME;
    static const vespalib::string CONFIG_DEF_NAMESPACE;
    static const ::config::StringVector CONFIG_DEF_SCHEMA;
    static const int64_t CONFIG_DEF_SERIALIZE_VERSION;

    RouteVector route;
};

} // namespace internal

typedef internal::InternalDocumentrouteselectorpolicyType DocumentrouteselectorpolicyConfigBuilder;
typedef const internal::InternalDocumentrouteselectorpolicyType DocumentrouteselectorpolicyConfig;

} // namespace documentapi::messagebus::protocol
#endif // VESPA_config_DOCUMENTAPI_MESSAGEBUS_PROTOCOL_DOCUMENTROUTESELECTORPOLICY_H
