#include "config-filedistributorrpc.h"
#include <vespa/config/common/configvalue.h>
#include <vespa/config/common/exceptions.h>
#include <vespa/config/configgen/configpayload.h>
#include <vespa/config/print/configdatabuffer.h>
#include <vespa/config/common/configparser.h>
#include <vespa/vespalib/data/slime/convenience.h>
#include <vespa/vespalib/data/slime/slime.h>
#include <vespa/vespalib/stllike/asciistream.h>
#include <vespa/config/configgen/vector_inserter.hpp>
#include <vespa/config/configgen/map_inserter.hpp>

namespace cloud::config::filedistribution {

namespace internal {

using ::config::ConfigParser;
using ::config::InvalidConfigException;
using ::config::ConfigInstance;
using ::config::ConfigValue;
using namespace vespalib::slime::convenience;

const vespalib::string InternalFiledistributorrpcType::CONFIG_DEF_MD5("7a139e62d1f3c0354d724e7f49b648fc");
const vespalib::string InternalFiledistributorrpcType::CONFIG_DEF_NAME("filedistributorrpc");
const vespalib::string InternalFiledistributorrpcType::CONFIG_DEF_NAMESPACE("cloud.config.filedistribution");
const int64_t InternalFiledistributorrpcType::CONFIG_DEF_SERIALIZE_VERSION(1);
const static vespalib::string __internalDefSchema[] = {
"namespace=cloud.config.filedistribution",
"connectionspec string",
};
const ::config::StringVector InternalFiledistributorrpcType::CONFIG_DEF_SCHEMA(__internalDefSchema,
    __internalDefSchema + (sizeof(__internalDefSchema) / 
                           sizeof(__internalDefSchema[0])));

InternalFiledistributorrpcType::InternalFiledistributorrpcType() noexcept
    : connectionspec()
{
}

InternalFiledistributorrpcType::InternalFiledistributorrpcType(const InternalFiledistributorrpcType & __rhs) noexcept = default;
InternalFiledistributorrpcType & InternalFiledistributorrpcType::operator =(const InternalFiledistributorrpcType & __rhs) noexcept = default;
InternalFiledistributorrpcType::InternalFiledistributorrpcType(InternalFiledistributorrpcType && __rhs) noexcept = default;
InternalFiledistributorrpcType & InternalFiledistributorrpcType::operator =(InternalFiledistributorrpcType && __rhs) noexcept = default;
InternalFiledistributorrpcType::~InternalFiledistributorrpcType() = default; 
InternalFiledistributorrpcType::InternalFiledistributorrpcType(const ConfigValue & __value)
{
    try {
        const ::config::StringVector & __lines(__value.getLines());
        std::set<vespalib::string> __remainingValuesToParse = ConfigParser::getUniqueNonWhiteSpaceLines(__lines);
        connectionspec = ConfigParser::parse<vespalib::string>("connectionspec", __lines);
        ConfigParser::stripLinesForKey("connectionspec", __remainingValuesToParse);
    } catch (InvalidConfigException & __ice) {
        throw InvalidConfigException("Error parsing config '" + CONFIG_DEF_NAME + "' in namespace '" + CONFIG_DEF_NAMESPACE + "': " + __ice.getMessage());
    }
}

bool
InternalFiledistributorrpcType::
operator==(const InternalFiledistributorrpcType& __rhs) const noexcept
{
    return (connectionspec == __rhs.connectionspec);
}

bool
InternalFiledistributorrpcType::
operator!=(const InternalFiledistributorrpcType& __rhs) const noexcept
{
    return !(operator==(__rhs));
}

void
InternalFiledistributorrpcType::serialize(::config::ConfigDataBuffer & __buffer) const
{
    vespalib::Slime & __slime(__buffer.slimeObject());
    vespalib::slime::Cursor & __croot = __slime.setObject();
    __croot.setDouble("version", CONFIG_DEF_SERIALIZE_VERSION);
    vespalib::slime::Cursor & __key = __croot.setObject("configKey");
    __key.setString("defName", vespalib::Memory(CONFIG_DEF_NAME));
    __key.setString("defNamespace", vespalib::Memory(CONFIG_DEF_NAMESPACE));
    __key.setString("defMd5", vespalib::Memory(CONFIG_DEF_MD5));
    vespalib::slime::Cursor & __keySchema =__key.setArray("defSchema");
    for (size_t i = 0; i < CONFIG_DEF_SCHEMA.size(); i++) {
        __keySchema.addString(vespalib::Memory(CONFIG_DEF_SCHEMA[i]));
    }
    vespalib::slime::Cursor & __cursor = __croot.setObject("configPayload");
    {
        vespalib::slime::Cursor & __c = __cursor.setObject("connectionspec");
        __c.setString("type", "string");
        __c.setString("value", vespalib::Memory(connectionspec));
    }
}

InternalFiledistributorrpcType::InternalFiledistributorrpcType(const ::config::ConfigDataBuffer & __buffer)
{
    const vespalib::Slime & __slime(__buffer.slimeObject());
    vespalib::slime::Inspector & __croot = __slime.get();
    vespalib::slime::Inspector & __inspector = __croot["configPayload"];
    connectionspec = __inspector["connectionspec"]["value"].asString().make_string();
}

InternalFiledistributorrpcType::InternalFiledistributorrpcType(const ::config::ConfigPayload & __payload)
{
    const vespalib::slime::Inspector & __inspector(__payload.get());
    connectionspec = ::config::internal::ValueConverter<vespalib::string>()("connectionspec", __inspector["connectionspec"]);
}

} // namespace internal

} // namespace cloud::config::filedistribution
