/**
 * @class cloud::config::filedistribution::Filedistributorrpc
 * @ingroup config
 *
 * @brief This is an autogenerated class for handling VESPA config.
 *
 * This class is autogenerated by vespa from a config definition file.
 * To subscribe to config, you need to include the config/config.h header, 
 * and create a ConfigSubscriber in order to subscribe for config.
 *
 * Copyright Vespa.ai. Licensed under the terms of the Apache 2.0 license. See LICENSE in the project root.
 */
#ifndef CLOUD_CONFIG_CLOUD_CONFIG_FILEDISTRIBUTION_FILEDISTRIBUTORRPC_H
#define CLOUD_CONFIG_CLOUD_CONFIG_FILEDISTRIBUTION_FILEDISTRIBUTORRPC_H

#include <vespa/config/configgen/configinstance.h>
#include <vespa/config/common/types.h>

namespace config {
    class ConfigValue;
    class ConfigPayload;
}

namespace vespalib::slime {
    struct Inspector;
    struct Cursor;
}

namespace cloud::config::filedistribution {

namespace internal {

/**
 * This class contains the config. DO NOT USE THIS CLASS DIRECTLY. Use the typedeffed
 * versions after this class declaration.
 */
class InternalFiledistributorrpcType : public ::config::ConfigInstance
{
public:
    typedef std::unique_ptr<const InternalFiledistributorrpcType> UP;
    const vespalib::string & defName() const override { return CONFIG_DEF_NAME; }
    const vespalib::string & defMd5() const override { return CONFIG_DEF_MD5; }
    const vespalib::string & defNamespace() const override { return CONFIG_DEF_NAMESPACE; }
    void serialize(::config::ConfigDataBuffer & __buffer) const override;
    InternalFiledistributorrpcType(const ::config::ConfigValue & __value);
    InternalFiledistributorrpcType(const ::config::ConfigDataBuffer & __value);
    InternalFiledistributorrpcType(const ::config::ConfigPayload & __payload);
    InternalFiledistributorrpcType()  noexcept;
    InternalFiledistributorrpcType(const InternalFiledistributorrpcType & __rhs) noexcept;
    InternalFiledistributorrpcType & operator = (const InternalFiledistributorrpcType & __rhs) noexcept;
    InternalFiledistributorrpcType(InternalFiledistributorrpcType && __rhs) noexcept;
    InternalFiledistributorrpcType & operator = (InternalFiledistributorrpcType && __rhs) noexcept;
    ~InternalFiledistributorrpcType();

    bool operator==(const InternalFiledistributorrpcType& __rhs) const noexcept;
    bool operator!=(const InternalFiledistributorrpcType& __rhs) const noexcept;

    static const vespalib::string CONFIG_DEF_MD5;
    static const vespalib::string CONFIG_DEF_NAME;
    static const vespalib::string CONFIG_DEF_NAMESPACE;
    static const ::config::StringVector CONFIG_DEF_SCHEMA;
    static const int64_t CONFIG_DEF_SERIALIZE_VERSION;

    vespalib::string connectionspec;
};

} // namespace internal

typedef internal::InternalFiledistributorrpcType FiledistributorrpcConfigBuilder;
typedef const internal::InternalFiledistributorrpcType FiledistributorrpcConfig;

} // namespace cloud::config::filedistribution
#endif // VESPA_config_CLOUD_CONFIG_FILEDISTRIBUTION_FILEDISTRIBUTORRPC_H
