/**
 * @class vespa::config::search::core::VerifyRanksetup
 * @ingroup config
 *
 * @brief This is an autogenerated class for handling VESPA config.
 *
 * This class is autogenerated by vespa from a config definition file.
 * To subscribe to config, you need to include the config/config.h header, 
 * and create a ConfigSubscriber in order to subscribe for config.
 *
 * Copyright Vespa.ai. Licensed under the terms of the Apache 2.0 license. See LICENSE in the project root.
 */
#ifndef CLOUD_CONFIG_VESPA_CONFIG_SEARCH_CORE_VERIFYRANKSETUP_H
#define CLOUD_CONFIG_VESPA_CONFIG_SEARCH_CORE_VERIFYRANKSETUP_H

#include <vespa/config/configgen/configinstance.h>
#include <vespa/config/common/types.h>

namespace config {
    class ConfigValue;
    class ConfigPayload;
}

namespace vespalib::slime {
    struct Inspector;
    struct Cursor;
}

namespace vespa::config::search::core {

namespace internal {

/**
 * This class contains the config. DO NOT USE THIS CLASS DIRECTLY. Use the typedeffed
 * versions after this class declaration.
 */
class InternalVerifyRanksetupType : public ::config::ConfigInstance
{
public:
    typedef std::unique_ptr<const InternalVerifyRanksetupType> UP;
    class File {
    public:
        File(const ::config::StringVector & __lines);
        File(const vespalib::slime::Inspector & __inspector);
        File(const ::config::ConfigPayload & __payload);
        File()  noexcept;
        File(const File & __rhs) noexcept;
        File & operator = (const File & __rhs) noexcept;
        File(File && __rhs) noexcept;
        File & operator = (File && __rhs) noexcept;
        ~File();

        bool operator==(const File& __rhs) const noexcept;
        bool operator!=(const File& __rhs) const noexcept;

        void serialize(vespalib::slime::Cursor & __cursor) const;
        vespalib::string ref;
        vespalib::string path;
    };
    typedef std::vector<File> FileVector;

    typedef std::map<vespalib::string, File> FileMap;

    const vespalib::string & defName() const override { return CONFIG_DEF_NAME; }
    const vespalib::string & defMd5() const override { return CONFIG_DEF_MD5; }
    const vespalib::string & defNamespace() const override { return CONFIG_DEF_NAMESPACE; }
    void serialize(::config::ConfigDataBuffer & __buffer) const override;
    InternalVerifyRanksetupType(const ::config::ConfigValue & __value);
    InternalVerifyRanksetupType(const ::config::ConfigDataBuffer & __value);
    InternalVerifyRanksetupType(const ::config::ConfigPayload & __payload);
    InternalVerifyRanksetupType() ;
    InternalVerifyRanksetupType(const InternalVerifyRanksetupType & __rhs);
    InternalVerifyRanksetupType & operator = (const InternalVerifyRanksetupType & __rhs);
    InternalVerifyRanksetupType(InternalVerifyRanksetupType && __rhs) noexcept;
    InternalVerifyRanksetupType & operator = (InternalVerifyRanksetupType && __rhs) noexcept;
    ~InternalVerifyRanksetupType();

    bool operator==(const InternalVerifyRanksetupType& __rhs) const noexcept;
    bool operator!=(const InternalVerifyRanksetupType& __rhs) const noexcept;

    static const vespalib::string CONFIG_DEF_MD5;
    static const vespalib::string CONFIG_DEF_NAME;
    static const vespalib::string CONFIG_DEF_NAMESPACE;
    static const ::config::StringVector CONFIG_DEF_SCHEMA;
    static const int64_t CONFIG_DEF_SERIALIZE_VERSION;

    FileVector file;
};

} // namespace internal

typedef internal::InternalVerifyRanksetupType VerifyRanksetupConfigBuilder;
typedef const internal::InternalVerifyRanksetupType VerifyRanksetupConfig;

} // namespace vespa::config::search::core
#endif // VESPA_config_VESPA_CONFIG_SEARCH_CORE_VERIFYRANKSETUP_H
