/**
 * @class vespa::config::content::core::RpcProvider
 * @ingroup config
 *
 * @brief This is an autogenerated class for handling VESPA config.
 *
 * This class is autogenerated by vespa from a config definition file.
 * To subscribe to config, you need to include the config/config.h header, 
 * and create a ConfigSubscriber in order to subscribe for config.
 *
 * Copyright Vespa.ai. Licensed under the terms of the Apache 2.0 license. See LICENSE in the project root.
 */
#ifndef CLOUD_CONFIG_VESPA_CONFIG_CONTENT_CORE_RPCPROVIDER_H
#define CLOUD_CONFIG_VESPA_CONFIG_CONTENT_CORE_RPCPROVIDER_H

#include <vespa/config/configgen/configinstance.h>
#include <vespa/config/common/types.h>

namespace config {
    class ConfigValue;
    class ConfigPayload;
}

namespace vespalib::slime {
    struct Inspector;
    struct Cursor;
}

namespace vespa::config::content::core {

namespace internal {

/**
 * This class contains the config. DO NOT USE THIS CLASS DIRECTLY. Use the typedeffed
 * versions after this class declaration.
 */
class InternalRpcProviderType : public ::config::ConfigInstance
{
public:
    typedef std::unique_ptr<const InternalRpcProviderType> UP;
    const vespalib::string & defName() const override { return CONFIG_DEF_NAME; }
    const vespalib::string & defMd5() const override { return CONFIG_DEF_MD5; }
    const vespalib::string & defNamespace() const override { return CONFIG_DEF_NAMESPACE; }
    void serialize(::config::ConfigDataBuffer & __buffer) const override;
    InternalRpcProviderType(const ::config::ConfigValue & __value);
    InternalRpcProviderType(const ::config::ConfigDataBuffer & __value);
    InternalRpcProviderType(const ::config::ConfigPayload & __payload);
    InternalRpcProviderType()  noexcept;
    InternalRpcProviderType(const InternalRpcProviderType & __rhs) noexcept;
    InternalRpcProviderType & operator = (const InternalRpcProviderType & __rhs) noexcept;
    InternalRpcProviderType(InternalRpcProviderType && __rhs) noexcept;
    InternalRpcProviderType & operator = (InternalRpcProviderType && __rhs) noexcept;
    ~InternalRpcProviderType();

    bool operator==(const InternalRpcProviderType& __rhs) const noexcept;
    bool operator!=(const InternalRpcProviderType& __rhs) const noexcept;

    static const vespalib::string CONFIG_DEF_MD5;
    static const vespalib::string CONFIG_DEF_NAME;
    static const vespalib::string CONFIG_DEF_NAMESPACE;
    static const ::config::StringVector CONFIG_DEF_SCHEMA;
    static const int64_t CONFIG_DEF_SERIALIZE_VERSION;

    vespalib::string connectspec; // Default: "tcp/localhost:17777"
};

} // namespace internal

typedef internal::InternalRpcProviderType RpcProviderConfigBuilder;
typedef const internal::InternalRpcProviderType RpcProviderConfig;

} // namespace vespa::config::content::core
#endif // VESPA_config_VESPA_CONFIG_CONTENT_CORE_RPCPROVIDER_H
