/**
 * @class vespa::config::content::core::StorBouncer
 * @ingroup config
 *
 * @brief This is an autogenerated class for handling VESPA config.
 *
 * This class is autogenerated by vespa from a config definition file.
 * To subscribe to config, you need to include the config/config.h header, 
 * and create a ConfigSubscriber in order to subscribe for config.
 *
 * Copyright Vespa.ai. Licensed under the terms of the Apache 2.0 license. See LICENSE in the project root.
 */
#ifndef CLOUD_CONFIG_VESPA_CONFIG_CONTENT_CORE_STORBOUNCER_H
#define CLOUD_CONFIG_VESPA_CONFIG_CONTENT_CORE_STORBOUNCER_H

#include <vespa/config/configgen/configinstance.h>
#include <vespa/config/common/types.h>

namespace config {
    class ConfigValue;
    class ConfigPayload;
}

namespace vespalib::slime {
    struct Inspector;
    struct Cursor;
}

namespace vespa::config::content::core {

namespace internal {

/**
 * This class contains the config. DO NOT USE THIS CLASS DIRECTLY. Use the typedeffed
 * versions after this class declaration.
 */
class InternalStorBouncerType : public ::config::ConfigInstance
{
public:
    typedef std::unique_ptr<const InternalStorBouncerType> UP;
    const vespalib::string & defName() const override { return CONFIG_DEF_NAME; }
    const vespalib::string & defMd5() const override { return CONFIG_DEF_MD5; }
    const vespalib::string & defNamespace() const override { return CONFIG_DEF_NAMESPACE; }
    void serialize(::config::ConfigDataBuffer & __buffer) const override;
    InternalStorBouncerType(const ::config::ConfigValue & __value);
    InternalStorBouncerType(const ::config::ConfigDataBuffer & __value);
    InternalStorBouncerType(const ::config::ConfigPayload & __payload);
    InternalStorBouncerType()  noexcept;
    InternalStorBouncerType(const InternalStorBouncerType & __rhs) noexcept;
    InternalStorBouncerType & operator = (const InternalStorBouncerType & __rhs) noexcept;
    InternalStorBouncerType(InternalStorBouncerType && __rhs) noexcept;
    InternalStorBouncerType & operator = (InternalStorBouncerType && __rhs) noexcept;
    ~InternalStorBouncerType();

    bool operator==(const InternalStorBouncerType& __rhs) const noexcept;
    bool operator!=(const InternalStorBouncerType& __rhs) const noexcept;

    static const vespalib::string CONFIG_DEF_MD5;
    static const vespalib::string CONFIG_DEF_NAME;
    static const vespalib::string CONFIG_DEF_NAMESPACE;
    static const ::config::StringVector CONFIG_DEF_SCHEMA;
    static const int64_t CONFIG_DEF_SERIALIZE_VERSION;


    /**
     * The maximum clock skew allowed in the system. Any messages received
     * that have a timestamp longer in the future than this will be failed.
     */
    int32_t maxClockSkewSeconds; // Default: 5
};

} // namespace internal

typedef internal::InternalStorBouncerType StorBouncerConfigBuilder;
typedef const internal::InternalStorBouncerType StorBouncerConfig;

} // namespace vespa::config::content::core
#endif // VESPA_config_VESPA_CONFIG_CONTENT_CORE_STORBOUNCER_H
