/**
 * @class vespa::config::content::core::StorDistributormanager
 * @ingroup config
 *
 * @brief This is an autogenerated class for handling VESPA config.
 *
 * This class is autogenerated by vespa from a config definition file.
 * To subscribe to config, you need to include the config/config.h header, 
 * and create a ConfigSubscriber in order to subscribe for config.
 *
 * Copyright Vespa.ai. Licensed under the terms of the Apache 2.0 license. See LICENSE in the project root.
 */
#ifndef CLOUD_CONFIG_VESPA_CONFIG_CONTENT_CORE_STORDISTRIBUTORMANAGER_H
#define CLOUD_CONFIG_VESPA_CONFIG_CONTENT_CORE_STORDISTRIBUTORMANAGER_H

#include <vespa/config/configgen/configinstance.h>
#include <vespa/config/common/types.h>

namespace config {
    class ConfigValue;
    class ConfigPayload;
}

namespace vespalib::slime {
    struct Inspector;
    struct Cursor;
}

namespace vespa::config::content::core {

namespace internal {

/**
 * This class contains the config. DO NOT USE THIS CLASS DIRECTLY. Use the typedeffed
 * versions after this class declaration.
 */
class InternalStorDistributormanagerType : public ::config::ConfigInstance
{
public:
    typedef std::unique_ptr<const InternalStorDistributormanagerType> UP;
    class Garbagecollection {
    public:
        Garbagecollection(const ::config::StringVector & __lines);
        Garbagecollection(const vespalib::slime::Inspector & __inspector);
        Garbagecollection(const ::config::ConfigPayload & __payload);
        Garbagecollection()  noexcept;
        Garbagecollection(const Garbagecollection & __rhs) noexcept;
        Garbagecollection & operator = (const Garbagecollection & __rhs) noexcept;
        Garbagecollection(Garbagecollection && __rhs) noexcept;
        Garbagecollection & operator = (Garbagecollection && __rhs) noexcept;
        ~Garbagecollection();

        bool operator==(const Garbagecollection& __rhs) const noexcept;
        bool operator!=(const Garbagecollection& __rhs) const noexcept;

        void serialize(vespalib::slime::Cursor & __cursor) const;

        /**
         * If non-empty, continuously delete all the documents matching this
         * selection.
         */
        vespalib::string selectiontoremove; // Default: ""

        /**
         * The interval with which each bucket is purged using the selection
         * above.
         * If 0, no garbage collection is done.
         */
        int32_t interval; // Default: 0
    };
    typedef std::vector<Garbagecollection> GarbagecollectionVector;

    typedef std::map<vespalib::string, Garbagecollection> GarbagecollectionMap;

    enum class MinimumReplicaCountingMode { TRUSTED, ANY };
    typedef std::vector<MinimumReplicaCountingMode> MinimumReplicaCountingModeVector;
    typedef std::map<vespalib::string, MinimumReplicaCountingMode> MinimumReplicaCountingModeMap;
    static MinimumReplicaCountingMode getMinimumReplicaCountingMode(const vespalib::string&);
    static vespalib::string getMinimumReplicaCountingModeName(MinimumReplicaCountingMode e);

    struct InternalMinimumReplicaCountingModeConverter {
        MinimumReplicaCountingMode operator()(const ::vespalib::string & __fieldName, const ::vespalib::slime::Inspector & __inspector);
        MinimumReplicaCountingMode operator()(const ::vespalib::slime::Inspector & __inspector);
        MinimumReplicaCountingMode operator()(const ::vespalib::slime::Inspector & __inspector, MinimumReplicaCountingMode __eDefault);
    };
    const vespalib::string & defName() const override { return CONFIG_DEF_NAME; }
    const vespalib::string & defMd5() const override { return CONFIG_DEF_MD5; }
    const vespalib::string & defNamespace() const override { return CONFIG_DEF_NAMESPACE; }
    void serialize(::config::ConfigDataBuffer & __buffer) const override;
    InternalStorDistributormanagerType(const ::config::ConfigValue & __value);
    InternalStorDistributormanagerType(const ::config::ConfigDataBuffer & __value);
    InternalStorDistributormanagerType(const ::config::ConfigPayload & __payload);
    InternalStorDistributormanagerType()  noexcept;
    InternalStorDistributormanagerType(const InternalStorDistributormanagerType & __rhs) noexcept;
    InternalStorDistributormanagerType & operator = (const InternalStorDistributormanagerType & __rhs) noexcept;
    InternalStorDistributormanagerType(InternalStorDistributormanagerType && __rhs) noexcept;
    InternalStorDistributormanagerType & operator = (InternalStorDistributormanagerType && __rhs) noexcept;
    ~InternalStorDistributormanagerType();

    bool operator==(const InternalStorDistributormanagerType& __rhs) const noexcept;
    bool operator!=(const InternalStorDistributormanagerType& __rhs) const noexcept;

    static const vespalib::string CONFIG_DEF_MD5;
    static const vespalib::string CONFIG_DEF_NAME;
    static const vespalib::string CONFIG_DEF_NAMESPACE;
    static const ::config::StringVector CONFIG_DEF_SCHEMA;
    static const int64_t CONFIG_DEF_SERIALIZE_VERSION;


    /**
     * The total size of unique documents in a bucket before we split it due to
     * being too big. By default this is now 16 MB. Should be kept in sync with
     * stor-filestor.def:bucket_merge_chunk_size.
     */
    int32_t splitsize; // Default: 16772216

    /**
     * The maximum amount of entries in a file before we should attempt to split
     * it.
     * A meta data entry in a slotfile currently uses 40 bytes. It is probably
     * good to have the split size, such that all meta data entries are normally
     * read when you do the initial read. With the default of 1024, meta data
     * will
     * take up around 40 kB, and the default initial read is 64 kB, allowing the
     * file to grow a bit above max and still all be read in initial read.
     */
    int32_t splitcount; // Default: 1024

    /**
     * The maximum size of unique documents that allows the system to reduce
     * the number of split bits on the bucket, or join two buckets together.
     * The size must be lower than this number, and the count must be lower than
     * joincount.
     */
    int32_t joinsize; // Default: 16000000

    /**
     * The maximum number of unique documents that allows for joining (see
     * joinsize).
     */
    int32_t joincount; // Default: 512

    /** Minimum level of splitting for buckets */
    int32_t minsplitcount; // Default: 16
    Garbagecollection garbagecollection;

    /** If false, dont do splits inline with feeding. */
    bool inlinebucketsplitting; // Default: true

    /**
     * Maximum nodes involved in a merge operation. Currently, this can not be
     * more
     * than 16 nodes due to protocol limitations. However, decreasing the max
     * may
     * be useful if 16 node merges ends up too expensive.
     */
    int32_t maximumNodesPerMerge; // Default: 16

    /**
     * For internal in process debugging, it may be useful to not start the
     * distributor thread to be able to call tick() manually and run single
     * threaded
     */
    bool startDistributorThread; // Default: true

    /**
     * The distributor can send joins that "lift" a bucket without any siblings
     * higher up in the bucket tree hierarchy. The assumption is that if this
     * is done for all sibling-less buckets, they will all eventually reach a
     * level in the tree where they do in fact have a sibling and may (if their
     * sizes allow) be joined into a single bucket.
     */
    bool enableJoinForSiblingLessBuckets; // Default: false

    /**
     * There exists a distribution edge case where bucket siblings end up having
     * non-equal ideal locations. This will normally inhibit join operations, as
     * these are only allowed when all nodes have all source buckets involved in
     * the join operation. Setting this property to true means such buckets may
     * still be joined at the cost of transient inconsistencies for the buckets
     * being joined into.
     */
    bool enableInconsistentJoin; // Default: false

    /**
     * For each available node, the distributor will report back to the cluster
     * controller a value which indicates the minimum replication factor for any
     * bucket contained on said node. This config exposes a way to alter how
     * this
     * replication factor is computed.
     *  
     * Valid enum values and their semantics:
     *  
     * TRUSTED - only trusted replicas are counted.
     * ANY - any replica present is counted. This may return an overly
     * optimistic
     * view of the system. E.g. if there are 3 replicas, 1 having 1000 docs
     * and 2 having 1 doc, all being out of sync, counting with ANY will still
     * treat this as a minimum replication factor of 3. Conversely, with
     * TRUSTED such a bucket would most likely have a factor of 0 (or 1 iff
     * the trusted status for the replica with 1000 docs is known).
     */
    MinimumReplicaCountingMode minimumReplicaCountingMode; // Default: TRUSTED

    /**
     * Bucket activation only makes sense for indexed search clusters, but
     * Proton
     * may also be run in store-only or streaming mode, in which case it does
     * not
     * actually require any activations. If the model infers that Proton is
     * running
     * in such a mode, activation will be explicitly disabled.
     *  
     * Activation is always disabled entirely for clusters using VDS as their
     * engine, regardless of the value of this setting.
     */
    bool disableBucketActivation; // Default: false

    /**
     * Maximum clock skew across nodes in the cluster, in whole seconds.
     * Used to prevent timestamp collisions during distributor bucket ownership
     * transfers.
     * Zero means this mechanism is disabled.
     */
    int32_t maxClusterClockSkewSec; // Default: 1

    /**
     * Number of seconds that scheduling of new merge operations should be
     * inhibited
     * towards a node if it has indicated that its merge queues are full or it
     * is
     * suffering from resource exhaustion.
     */
    int32_t inhibitMergeSendingOnBusyNodeDurationSec; // Default: 1

    /**
     * If set, enables potentially stale reads during cluster state transitions
     * where
     * buckets change ownership. This also implicitly enables support for
     * two-phase
     * cluster state transitions on the distributor.
     * For this option to take effect, the cluster controller must also have
     * two-phase
     * states enabled.
     */
    bool allowStaleReadsDuringClusterStateTransitions; // Default: false

    /**
     * If greater than zero, injects a thread sleep into certain parts of the
     * bucket
     * processing logic. This allows for easier testing of racing edge cases
     * where the
     * main distributor thread is CPU-blocked processing large amounts of
     * buckets, but
     * without actually needing to use a lot of buckets in the test itself.
     * Setting any of these values only makes sense for testing!
     */
    int32_t simulatedDbPruningLatencyMsec; // Default: 0
    int32_t simulatedDbMergingLatencyMsec; // Default: 0

    /**
     * If set, no merge operations may be generated for any reason by a
     * distributor.
     * This is ONLY intended for system testing of certain transient edge cases
     * and
     * MUST NOT be set to true in a production environment.
     */
    bool mergeOperationsDisabled; // Default: false

    /**
     * If set, Get operations that are initiated by the client (i.e. _not_ Get
     * operations
     * that are initiated by the distributor) will be forwarded to the backend
     * with
     * a flag signalling that weak read consistency may be used. This allows the
     * backend to minimize internal locking. The downside is that it's not
     * guaranteed
     * to observe the most recent writes to the document, nor to observe an
     * atomically
     * consistent view of fields across document versions.
     * This is mostly useful in a system that is effectively read-only.
     */
    bool useWeakInternalReadConsistencyForClientGets; // Default: false

    /**
     * If a distributor main thread tick is constantly processing requests or
     * responses
     * originating from other nodes, setting this value above zero will prevent
     * implicit
     * maintenance scans from being done as part of the tick for up to N rounds
     * of ticking.
     * This is to reduce the amount of CPU spent on ideal state calculations and
     * bucket DB
     * accesses when the distributor is heavily loaded with feed operations.
     */
    int32_t maxConsecutivelyInhibitedMaintenanceTicks; // Default: 20

    /**
     * If set, activation of bucket replicas is limited to only those replicas
     * that have
     * bucket info consistent with a majority of the other replicas for that
     * bucket.
     * Multiple active replicas is only a feature that is enabled for grouped
     * clusters,
     * and this feature is intended to prevent nodes in stale groups (whose
     * buckets are
     * likely to be out of sync) from serving query traffic until they have
     * gotten back
     * into sync.
     * Up to the given number of groups can have their replica activation
     * inhibited
     * by this feature. If zero, the feature is functionally disabled.
     * If more groups are out of sync than the configured number N, the
     * inhibited groups
     * will be the N first groups present in the distribution config.
     * Note: this feature only kicks in if the number of groups in the cluster
     * is greater
     * than 1.
     */
    int32_t maxActivationInhibitedOutOfSyncGroups; // Default: 0

    /**
     * Specifies the number of stripes over which a distributor internally
     * distributes
     * its buckets and operation processing. Every stripe receives its own
     * thread.
     * If <= 0, the number of stripes is inferred automatically based on the
     * number of
     * CPU cores available. If > 0, the number of stripes is explicitly
     * overridden.
     * Stripe counts must be a power of two.
     */
    int32_t numDistributorStripes; // Default: 0

    /**
     * If true, changes in the cluster where a subset of the nodes become
     * unavailable or buckets
     * change ownership between distributors will trigger an explicit
     * cancellation of all pending
     * requests partially or fully "invalidated" by such a change.
     */
    bool enableOperationCancellation; // Default: false

    /**
     * Iff true there will be an 1-1 symmetry between the replicas chosen as
     * feed targets
     * for Put operations and the replica selection logic for bucket activation.
     * In particular,
     * the most preferred replica for feed will be the most preferred bucket for
     * activation.
     * This helps ensure that new versions of documents are routed to replicas
     * that are most
     * likely to reflect these changes as part of visible search results.
     */
    bool symmetricPutAndActivateReplicaSelection; // Default: false

    /** TODO GC very soon, it has no effect. */
    int32_t priorityMergeOutOfSyncCopies; // Default: 120

    /** TODO GC as it has no effect */
    bool useBtreeDatabase; // Default: true
};

} // namespace internal

typedef internal::InternalStorDistributormanagerType StorDistributormanagerConfigBuilder;
typedef const internal::InternalStorDistributormanagerType StorDistributormanagerConfig;

} // namespace vespa::config::content::core
#endif // VESPA_config_VESPA_CONFIG_CONTENT_CORE_STORDISTRIBUTORMANAGER_H
