/**
 * @class vespa::config::content::core::StorPrioritymapping
 * @ingroup config
 *
 * @brief This is an autogenerated class for handling VESPA config.
 *
 * This class is autogenerated by vespa from a config definition file.
 * To subscribe to config, you need to include the config/config.h header, 
 * and create a ConfigSubscriber in order to subscribe for config.
 *
 * Copyright Vespa.ai. Licensed under the terms of the Apache 2.0 license. See LICENSE in the project root.
 */
#ifndef CLOUD_CONFIG_VESPA_CONFIG_CONTENT_CORE_STORPRIORITYMAPPING_H
#define CLOUD_CONFIG_VESPA_CONFIG_CONTENT_CORE_STORPRIORITYMAPPING_H

#include <vespa/config/configgen/configinstance.h>
#include <vespa/config/common/types.h>

namespace config {
    class ConfigValue;
    class ConfigPayload;
}

namespace vespalib::slime {
    struct Inspector;
    struct Cursor;
}

namespace vespa::config::content::core {

namespace internal {

/**
 * This class contains the config. DO NOT USE THIS CLASS DIRECTLY. Use the typedeffed
 * versions after this class declaration.
 */
class InternalStorPrioritymappingType : public ::config::ConfigInstance
{
public:
    typedef std::unique_ptr<const InternalStorPrioritymappingType> UP;
    const vespalib::string & defName() const override { return CONFIG_DEF_NAME; }
    const vespalib::string & defMd5() const override { return CONFIG_DEF_MD5; }
    const vespalib::string & defNamespace() const override { return CONFIG_DEF_NAMESPACE; }
    void serialize(::config::ConfigDataBuffer & __buffer) const override;
    InternalStorPrioritymappingType(const ::config::ConfigValue & __value);
    InternalStorPrioritymappingType(const ::config::ConfigDataBuffer & __value);
    InternalStorPrioritymappingType(const ::config::ConfigPayload & __payload);
    InternalStorPrioritymappingType()  noexcept;
    InternalStorPrioritymappingType(const InternalStorPrioritymappingType & __rhs) noexcept;
    InternalStorPrioritymappingType & operator = (const InternalStorPrioritymappingType & __rhs) noexcept;
    InternalStorPrioritymappingType(InternalStorPrioritymappingType && __rhs) noexcept;
    InternalStorPrioritymappingType & operator = (InternalStorPrioritymappingType && __rhs) noexcept;
    ~InternalStorPrioritymappingType();

    bool operator==(const InternalStorPrioritymappingType& __rhs) const noexcept;
    bool operator!=(const InternalStorPrioritymappingType& __rhs) const noexcept;

    static const vespalib::string CONFIG_DEF_MD5;
    static const vespalib::string CONFIG_DEF_NAME;
    static const vespalib::string CONFIG_DEF_NAMESPACE;
    static const ::config::StringVector CONFIG_DEF_SCHEMA;
    static const int64_t CONFIG_DEF_SERIALIZE_VERSION;

    int32_t highest; // Default: 50
    int32_t veryHigh; // Default: 60
    int32_t high1; // Default: 70
    int32_t high2; // Default: 80
    int32_t high3; // Default: 90
    int32_t normal1; // Default: 100
    int32_t normal2; // Default: 110
    int32_t normal3; // Default: 120
    int32_t normal4; // Default: 130
    int32_t normal5; // Default: 140
    int32_t normal6; // Default: 150
    int32_t low1; // Default: 160
    int32_t low2; // Default: 170
    int32_t low3; // Default: 180
    int32_t veryLow; // Default: 190
    int32_t lowest; // Default: 200
};

} // namespace internal

typedef internal::InternalStorPrioritymappingType StorPrioritymappingConfigBuilder;
typedef const internal::InternalStorPrioritymappingType StorPrioritymappingConfig;

} // namespace vespa::config::content::core
#endif // VESPA_config_VESPA_CONFIG_CONTENT_CORE_STORPRIORITYMAPPING_H
