/**
 * @class vespa::config::content::core::StorStatus
 * @ingroup config
 *
 * @brief This is an autogenerated class for handling VESPA config.
 *
 * This class is autogenerated by vespa from a config definition file.
 * To subscribe to config, you need to include the config/config.h header, 
 * and create a ConfigSubscriber in order to subscribe for config.
 *
 * Copyright Vespa.ai. Licensed under the terms of the Apache 2.0 license. See LICENSE in the project root.
 */
#ifndef CLOUD_CONFIG_VESPA_CONFIG_CONTENT_CORE_STORSTATUS_H
#define CLOUD_CONFIG_VESPA_CONFIG_CONTENT_CORE_STORSTATUS_H

#include <vespa/config/configgen/configinstance.h>
#include <vespa/config/common/types.h>

namespace config {
    class ConfigValue;
    class ConfigPayload;
}

namespace vespalib::slime {
    struct Inspector;
    struct Cursor;
}

namespace vespa::config::content::core {

namespace internal {

/**
 * This class contains the config. DO NOT USE THIS CLASS DIRECTLY. Use the typedeffed
 * versions after this class declaration.
 */
class InternalStorStatusType : public ::config::ConfigInstance
{
public:
    typedef std::unique_ptr<const InternalStorStatusType> UP;
    const vespalib::string & defName() const override { return CONFIG_DEF_NAME; }
    const vespalib::string & defMd5() const override { return CONFIG_DEF_MD5; }
    const vespalib::string & defNamespace() const override { return CONFIG_DEF_NAMESPACE; }
    void serialize(::config::ConfigDataBuffer & __buffer) const override;
    InternalStorStatusType(const ::config::ConfigValue & __value);
    InternalStorStatusType(const ::config::ConfigDataBuffer & __value);
    InternalStorStatusType(const ::config::ConfigPayload & __payload);
    InternalStorStatusType()  noexcept;
    InternalStorStatusType(const InternalStorStatusType & __rhs) noexcept;
    InternalStorStatusType & operator = (const InternalStorStatusType & __rhs) noexcept;
    InternalStorStatusType(InternalStorStatusType && __rhs) noexcept;
    InternalStorStatusType & operator = (InternalStorStatusType && __rhs) noexcept;
    ~InternalStorStatusType();

    bool operator==(const InternalStorStatusType& __rhs) const noexcept;
    bool operator!=(const InternalStorStatusType& __rhs) const noexcept;

    static const vespalib::string CONFIG_DEF_MD5;
    static const vespalib::string CONFIG_DEF_NAME;
    static const vespalib::string CONFIG_DEF_NAMESPACE;
    static const ::config::StringVector CONFIG_DEF_SCHEMA;
    static const int64_t CONFIG_DEF_SERIALIZE_VERSION;

    int32_t httpport; // Default: 0
};

} // namespace internal

typedef internal::InternalStorStatusType StorStatusConfigBuilder;
typedef const internal::InternalStorStatusType StorStatusConfig;

} // namespace vespa::config::content::core
#endif // VESPA_config_VESPA_CONFIG_CONTENT_CORE_STORSTATUS_H
