/**
 * @class vespa::config::content::core::StorVisitordispatcher
 * @ingroup config
 *
 * @brief This is an autogenerated class for handling VESPA config.
 *
 * This class is autogenerated by vespa from a config definition file.
 * To subscribe to config, you need to include the config/config.h header, 
 * and create a ConfigSubscriber in order to subscribe for config.
 *
 * Copyright Vespa.ai. Licensed under the terms of the Apache 2.0 license. See LICENSE in the project root.
 */
#ifndef CLOUD_CONFIG_VESPA_CONFIG_CONTENT_CORE_STORVISITORDISPATCHER_H
#define CLOUD_CONFIG_VESPA_CONFIG_CONTENT_CORE_STORVISITORDISPATCHER_H

#include <vespa/config/configgen/configinstance.h>
#include <vespa/config/common/types.h>

namespace config {
    class ConfigValue;
    class ConfigPayload;
}

namespace vespalib::slime {
    struct Inspector;
    struct Cursor;
}

namespace vespa::config::content::core {

namespace internal {

/**
 * This class contains the config. DO NOT USE THIS CLASS DIRECTLY. Use the typedeffed
 * versions after this class declaration.
 */
class InternalStorVisitordispatcherType : public ::config::ConfigInstance
{
public:
    typedef std::unique_ptr<const InternalStorVisitordispatcherType> UP;
    const vespalib::string & defName() const override { return CONFIG_DEF_NAME; }
    const vespalib::string & defMd5() const override { return CONFIG_DEF_MD5; }
    const vespalib::string & defNamespace() const override { return CONFIG_DEF_NAMESPACE; }
    void serialize(::config::ConfigDataBuffer & __buffer) const override;
    InternalStorVisitordispatcherType(const ::config::ConfigValue & __value);
    InternalStorVisitordispatcherType(const ::config::ConfigDataBuffer & __value);
    InternalStorVisitordispatcherType(const ::config::ConfigPayload & __payload);
    InternalStorVisitordispatcherType()  noexcept;
    InternalStorVisitordispatcherType(const InternalStorVisitordispatcherType & __rhs) noexcept;
    InternalStorVisitordispatcherType & operator = (const InternalStorVisitordispatcherType & __rhs) noexcept;
    InternalStorVisitordispatcherType(InternalStorVisitordispatcherType && __rhs) noexcept;
    InternalStorVisitordispatcherType & operator = (InternalStorVisitordispatcherType && __rhs) noexcept;
    ~InternalStorVisitordispatcherType();

    bool operator==(const InternalStorVisitordispatcherType& __rhs) const noexcept;
    bool operator!=(const InternalStorVisitordispatcherType& __rhs) const noexcept;

    static const vespalib::string CONFIG_DEF_MD5;
    static const vespalib::string CONFIG_DEF_NAME;
    static const vespalib::string CONFIG_DEF_NAMESPACE;
    static const ::config::StringVector CONFIG_DEF_SCHEMA;
    static const int64_t CONFIG_DEF_SERIALIZE_VERSION;


    /**
     * For any given client visitor operation, this specifies a maximum fan-out
     * factor for concurrent content node visitor operations towards a
     * particular
     * content node.
     * Having several visitor operations running concurrently increases the
     * potential data processing parallelism on the content nodes at the expense
     * of using additional resources.
     */
    int32_t maxvisitorspernodeperclientvisitor; // Default: 16

    /**
     * Minimum number of buckets that have to be present on a given content node
     * before more than one visitor operation may be sent in parallel towards
     * it.
     * This config is directly related to maxvisitorspernodeperclientvisitor.
     * Example: with max visitors of 4, min buckets of 5 and total of 40 buckets
     * on
     * a content node, a total of 4 visitors of 10 buckets each will be sent to
     * the
     * node. If min buckets were 20, only 2 visitors of 20 buckets each would be
     * sent.
     */
    int32_t minbucketspervisitor; // Default: 1
};

} // namespace internal

typedef internal::InternalStorVisitordispatcherType StorVisitordispatcherConfigBuilder;
typedef const internal::InternalStorVisitordispatcherType StorVisitordispatcherConfig;

} // namespace vespa::config::content::core
#endif // VESPA_config_VESPA_CONFIG_CONTENT_CORE_STORVISITORDISPATCHER_H
