/**
 * @class vespa::config::search::vsm::Vsm
 * @ingroup config
 *
 * @brief This is an autogenerated class for handling VESPA config.
 *
 * This class is autogenerated by vespa from a config definition file.
 * To subscribe to config, you need to include the config/config.h header, 
 * and create a ConfigSubscriber in order to subscribe for config.
 *
 * Copyright Vespa.ai. Licensed under the terms of the Apache 2.0 license. See LICENSE in the project root.
 */
#ifndef CLOUD_CONFIG_VESPA_CONFIG_SEARCH_VSM_VSM_H
#define CLOUD_CONFIG_VESPA_CONFIG_SEARCH_VSM_VSM_H

#include <vespa/config/configgen/configinstance.h>
#include <vespa/config/common/types.h>

namespace config {
    class ConfigValue;
    class ConfigPayload;
}

namespace vespalib::slime {
    struct Inspector;
    struct Cursor;
}

namespace vespa::config::search::vsm {

namespace internal {

/**
 * This class contains the config. DO NOT USE THIS CLASS DIRECTLY. Use the typedeffed
 * versions after this class declaration.
 */
class InternalVsmType : public ::config::ConfigInstance
{
public:
    typedef std::unique_ptr<const InternalVsmType> UP;
    const vespalib::string & defName() const override { return CONFIG_DEF_NAME; }
    const vespalib::string & defMd5() const override { return CONFIG_DEF_MD5; }
    const vespalib::string & defNamespace() const override { return CONFIG_DEF_NAMESPACE; }
    void serialize(::config::ConfigDataBuffer & __buffer) const override;
    InternalVsmType(const ::config::ConfigValue & __value);
    InternalVsmType(const ::config::ConfigDataBuffer & __value);
    InternalVsmType(const ::config::ConfigPayload & __payload);
    InternalVsmType()  noexcept;
    InternalVsmType(const InternalVsmType & __rhs) noexcept;
    InternalVsmType & operator = (const InternalVsmType & __rhs) noexcept;
    InternalVsmType(InternalVsmType && __rhs) noexcept;
    InternalVsmType & operator = (InternalVsmType && __rhs) noexcept;
    ~InternalVsmType();

    bool operator==(const InternalVsmType& __rhs) const noexcept;
    bool operator!=(const InternalVsmType& __rhs) const noexcept;

    static const vespalib::string CONFIG_DEF_MD5;
    static const vespalib::string CONFIG_DEF_NAME;
    static const vespalib::string CONFIG_DEF_NAMESPACE;
    static const ::config::StringVector CONFIG_DEF_SCHEMA;
    static const int64_t CONFIG_DEF_SERIALIZE_VERSION;


    /** The document model for the documents used as input for the VSM */
    vespalib::string doctype;

    /** Configuration for storage client used by VSM */
    vespalib::string storagecfg;

    /**
     * Config defining what search method should be applied to different
     * fields in the documents. It also contains a mapping from index name
     * to a set of fields making up that index.
     */
    vespalib::string vsmfields;
};

} // namespace internal

typedef internal::InternalVsmType VsmConfigBuilder;
typedef const internal::InternalVsmType VsmConfig;

} // namespace vespa::config::search::vsm
#endif // VESPA_config_VESPA_CONFIG_SEARCH_VSM_VSM_H
